package ve.gob.cnti.gestion.bonita;

import java.io.IOException;
import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.List;
import java.util.Map;

import org.json.JSONException;

import ve.gob.cnti.gestion.bonita.bean.Case;
import ve.gob.cnti.gestion.bonita.bean.ConsultaGenerica;

public interface ICase {
	/**
	 * TODO
	 * @param id
	 * @return
	 * @throws IOException 
	 * @throws JSONException 
	 * @throws IllegalStateException 
	 * @throws UnsupportedEncodingException 
	 */
	public Case getCase(String id) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException;


	/**
	 * Este método recibe el id de un usuario y devuelve la lista de casos que ese usuario ha iniciado
	 * @author José Francisco Luis Medina
	 * @param idUser
	 * @return
	 */
	public List<Case> listCases(String idUser);

	/**
	 * Método que retorna los nombres de las variables y sus valores correspondientes las claves disponibles son: description, name, value, case_id, type
	 * @author José Francisco Luis Medina
	 * @param idCase identificador del caso
	 */
	public List<Map<String, String>> getCaseVarValues(String idCase);
	
	public Case getCaseCompleted(String id);
	
	
	public List<ConsultaGenerica> getCasesHistoryByParameters(Map<String,String> parameters);
	
	public List<ConsultaGenerica> getCasesOnlineByCedula(String cedula);
	
	public List<Map<String,String>> getVariablesHistoryByCaseId(String caseId);

	/**
	 * Método que actualizar una variable es una instancia de caso
	 * @author José Francisco Luis Medina
	 * @param varName nombre de la variable a actualizar
	 * @param caseId identificador del caso
	 * @param varValue valor de la variable
	 */
	void updateCaseVariable(String varName, String caseId, Serializable varValue);


	Case getArchivedCase(String idCase);

}
