package ve.gob.cnti.gestion.bonita;

import java.util.List;

import ve.gob.cnti.gestion.bonita.bean.Comment;

public interface IComment {

	/**
	 * Este método devuelve la lista de comentarios asociados a un caso particular
	 * @author José Francisco Luis Medina
	 * @param processID recibe el id del caso
	 * @return List<Comment> devuelve la lista de comentarios
	 */
	List<Comment> getComments(long processID);
	
	/**
	 * Agrega un comentario a un caso
	 * @author José Francisco Luis Medina
	 * @param processID recibe el id del caso
	 * @param comment comentario a incluir
	 */
	void addComment(long processID, String comment);
	
	/**
	 * Este método devuelve la lista de comentarios asociados a un caso finalizado
	 * @author José Francisco Luis Medina
	 * @param processID recibe el id del caso
	 * @return List<Comment> devuelve la lista de comentarios
	
	*/
	public List<Comment> getCommentsCompleted(long processID);

}
