package ve.gob.cnti.gestion.bonita;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.List;
import java.util.Map;

import org.json.JSONException;

import ve.gob.cnti.gestion.bonita.bean.Task;

public interface IController {
	public Map<String, String> initCase(String idProc, String cedula) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException, InterruptedException;
	void completeTask(String idTask, List<Map<String, Object>> results);
	
	/**
	* La implementación de esta interfaz recibe el id de la tarea a realizar, la asigna al usuario en sesión y devuelve el nombre de la tarea pendiente para que sea renderizado el formulario
	* @author Jose Francisco Luis Medina
	* @param idTask id de la tarea a realizar
	 * @return 
	 * @throws IOException 
	 * @throws JSONException 
	 * @throws IllegalStateException 
	 * @throws UnsupportedEncodingException 
	*/
	String assignAndDoTask(String idTask) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException;
	
	/**
	 * 
	 * @param idCase
	 * @return
	 */
	List<Map<String, String>> getVariablesValues(String idCase);
	
	/**
	 * Este método retorna el id del usuario cuando se le entrega el id del mismo
	 * @param idUser
	 * @param idProcessDefinition
	 * @return
	 */
	//List<Task> gesTasksAvailableForUser(String idUser,
		//	String idProcessDefinition) throws JSONException, UnsupportedEncodingException, IllegalStateException, IOException;
	//List<Task> getTaskAvailableForUser(String idUser) throws JSONException, UnsupportedEncodingException, IllegalStateException, IOException;
	List<Task> gesTasksAvailableForUser(String idUser);
}
