package ve.gob.cnti.gestion.bonita;

import java.util.List;

import ve.gob.cnti.gestion.bonita.bean.Actor;
import ve.gob.cnti.gestion.bonita.bean.User;

public interface IUser {

	/**
	 * Este metodo devuelve los actores a los que esta asociado un usuario
	 * @author José Francisco Luis Medina
	 * @param {@link String}
	 * @return {@link List}<{@link Actor}>
	 */
	List<Actor> getActorByUserOnAProcess(String idUser,
			String idProcessDefinition);

	/**
	 * Devuelve un listado de los actores asociados al usuario indicado para todos los procesos
	 * @author José Francisco Luis Medina
	 * @param {@link String} idUser
	 * @return {@link List}<{@link Actor}>
	 */
	List<Actor> getActorByUser(String idUser);

	
	/**
	 * Devuelve el id del usuario cuando se le entrega el username 
	 * @author José Francisco Luis Medina
	 * @param {@link String} userName
	 * @return {@link String} idUser
	 */
	String getIdByuserName(String userName);

	/**
	 * Crea un usuario en el servidor de bonita definitiendo unicamente user y password
	 * @param username
	 * @param password
	 * @return
	 */
	String createUser(String username, String password);

	/**
	 * Devuelve el listado de usuarios candidatos a ejecutar la tarea indicada
	 * @author José Francisco Luis Medina
	 * @param idTask
	 * @return
	 */
	List<User> getUsersAvailablesForTask(String idTask);

	String getUsernameById(long userId);
	
	void updateUserPassword(String username, String password);


}
