package ve.gob.cnti.gestion.bonita.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class Actor {

	private String id;
	private String process_id;
	private String description;
	private String name;
	private String displayName;
	public Actor(String id, String process_id, String description, String name,
			String displayName) {
		super();
		this.id = id;
		this.process_id = process_id;
		this.description = description;
		this.name = name;
		this.displayName = displayName;
	}
	
	public Actor(){}
	
	/**
	 * Convierte un mapa string string en un un objeto de tipo Actor
	 * @author José Francisco Luis Medina
	 * @param map
	 * @return
	 */
	public Actor castToActorObj(Map<String,String> map){
		
		String[] valores = new String[map.size()];
		
		int i = 0;
		for(String val: map.values()){
			valores[i]=val;
			i++;
		}
		Actor actor = new Actor(valores[0],valores[1],valores[2],valores[3],valores[4]);
		return actor;
	}
	
	/**
	 * Convierte una lista de mapas string string en una lista de objetos tipo Actor
	 * @author José Francisco Luis Medina
	 * @param list
	 * @return
	 */
	public List<Actor>  castToListActorObj(List<Map<String,String>>  list){
		
		Iterator<Map<String,String>>  it = list.iterator();
		List<Actor> listObjets = new ArrayList<Actor>();
		
		while(it.hasNext()){
			 
			Map<String,String> map = new HashMap<String, String>();
			map = it.next();
			listObjets.add(this.castToActorObj(map));	
		}
		return listObjets;
	}
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getProcess_id() {
		return process_id;
	}
	public void setProcess_id(String process_id) {
		this.process_id = process_id;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getDisplayName() {
		return displayName;
	}
	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}
	@Override
	public String toString() {
		return "Actor [id=" + id + ", process_id=" + process_id
				+ ", description=" + description + ", name=" + name
				+ ", displayName=" + displayName + "]";
	}
	
}
