package ve.gob.cnti.gestion.bonita.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ActorMember {
	private String id;
	private String actor_id;
	private String role_id;
	private String group_id;
	private String user_id;
	public ActorMember(String id, String actor_id, String role_id,
			String group_id, String user_id) {
		super();
		this.id = id;
		this.actor_id = actor_id;
		this.role_id = role_id;
		this.group_id = group_id;
		this.user_id = user_id;
	}
	
	public ActorMember(){}
	
	/**
	 * Convierte un mapa string string en un un objeto de tipo ActorMember
	 * @author José Francisco Luis Medina
	 * @param map
	 * @return
	 */
	public ActorMember castToActorMemberObj(Map<String,String> map){
		
		String[] valores = new String[map.size()];
		
		int i = 0;
		for(String val: map.values()){
			valores[i]=val;
			i++;
		}
		ActorMember actorMember = new ActorMember(valores[0],valores[1],valores[2],valores[3],valores[4]);
		return actorMember;
	}
	
	/**
	 * Convierte una lista de mapas string string en una lista de objetos tipo ActorMember
	 * @author José Francisco Luis Medina
	 * @param list
	 * @return
	 */
	public List<ActorMember>  castToListActorMemberObj(List<Map<String,String>>  list){
		
		Iterator<Map<String,String>>  it = list.iterator();
		List<ActorMember> listObjets = new ArrayList<ActorMember>();
		
		while(it.hasNext()){
			 
			Map<String,String> map = new HashMap<String, String>();
			map = it.next();
			listObjets.add(this.castToActorMemberObj(map));	
		}
		return listObjets;
	}
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getActor_id() {
		return actor_id;
	}
	public void setActor_id(String actor_id) {
		this.actor_id = actor_id;
	}
	public String getRole_id() {
		return role_id;
	}
	public void setRole_id(String role_id) {
		this.role_id = role_id;
	}
	public String getGroup_id() {
		return group_id;
	}
	public void setGroup_id(String group_id) {
		this.group_id = group_id;
	}
	public String getUser_id() {
		return user_id;
	}
	public void setUser_id(String user_id) {
		this.user_id = user_id;
	}
	@Override
	public String toString() {
		return "ActorMember [id=" + id + ", actor_id=" + actor_id
				+ ", role_id=" + role_id + ", group_id=" + group_id
				+ ", user_id=" + user_id + "]";
	}
	
}
