package ve.gob.cnti.gestion.bonita.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class Case {
	
	private String id;
	private String end_date;
	private String start;
	private String state;
	private String rootCaseId;
	private String started_by;
	private String processDefinitionId;
	private String last_update_date;
	

	public Case(String id, String end_date, String start, String state, String rootCaseId, String started_by, String processDefinitionId, String last_update_date){
		super();
		this.id = id;
		this.end_date = end_date;
		this.start = start;
		this.state = state;
		this.rootCaseId = rootCaseId;
		this.started_by = started_by;
		this.processDefinitionId = processDefinitionId;
		this.last_update_date = last_update_date;
	}
	
	public Case(){
	}
	
	/**
	 * 
	 * @param list
	 * @return Lista de Objetos Case
	 */
	public List<Case>  castToListCaseObj(List<Map<String,String>>  list){
		
		Iterator<Map<String,String>>  it = list.iterator();
		List<Case> listObjets = new ArrayList<Case>();
		
		while(it.hasNext()){
			 
			Map<String,String> map = new HashMap<String, String>();
			map = it.next();
			listObjets.add(this.castToCaseObj(map));
			
		}
		
		return listObjets;
	}
	
	
	/**
	 * 
	 * @param map
	 * @return
	 */
	public Case castToCaseObj(Map<String,String> map){
		
		String[] valores = new String[map.size()];
		
		int i = 0;
		for(String val: map.values()){
			valores[i]=val;			
			i++;
		}
	
		Case cd = new Case(valores[0],valores[1],valores[2],valores[3],valores[4],valores[5],valores[6],valores[7]);
		
		return cd;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getEnd_date() {
		return end_date;
	}

	public void setEnd_date(String end_date) {
		this.end_date = end_date;
	}

	public String getStart() {
		return start;
	}

	public void setStart(String start) {
		this.start = start;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	
	public String getRootCaseId() {
		return rootCaseId;
	}

	public void setRootCaseId(String rootCaseId) {
		this.rootCaseId = rootCaseId;
	}

	public String getStarted_by() {
		return started_by;
	}

	public void setStarted_by(String started_by) {
		this.started_by = started_by;
	}

	public String getProcessDefinitionId() {
		return processDefinitionId;
	}

	public void setProcessDefinitionId(String processDefinitionId) {
		this.processDefinitionId = processDefinitionId;
	}

	public String getLast_update_date() {
		return last_update_date;
	}

	public void setLast_update_date(String last_update_date) {
		this.last_update_date = last_update_date;
	}

	@Override
	public String toString() {
		return "Case [id=" + id + ", end_date=" + end_date + ", start=" + start + ", state=" + state + ", rootCaseId="
				+ rootCaseId + ", started_by=" + started_by + ", processDefinitionId=" + processDefinitionId
				+ ", last_update_date=" + last_update_date + "]";
	}


		
}
