package ve.gob.cnti.gestion.bonita.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class Membership {
	
	private String assigned_date;
	private String role_id;
	private String assigned_by_user_id;
	private String group_id;
	private String user_id;
	public Membership(String assigned_date, String role_id,
			String assigned_by_user_id, String group_id, String user_id) {
		super();
		this.assigned_date = assigned_date;
		this.role_id = role_id;
		this.assigned_by_user_id = assigned_by_user_id;
		this.group_id = group_id;
		this.user_id = user_id;
	}
	
	public Membership(){}
	
	
	/**
	 * Convierte un mapa string string en un un objeto de tipo Membership
	 * @author José Francisco Luis Medina
	 * @param map
	 * @return
	 */
	public Membership castToMembershipObj(Map<String,String> map){
		
		String[] valores = new String[map.size()];
		
		int i = 0;
		for(String val: map.values()){
			valores[i]=val;
			i++;
		}
	
		Membership membership = new Membership(valores[0],valores[1],valores[2],valores[3],valores[4]);
		
		return membership;
	}
	
	/**
	 * Convierte una lista de mapas string string en una lista de objetos tipo Membership
	 * @author José Francisco Luis Medina
	 * @param list
	 * @return
	 */
	public List<Membership>  castToListMembershipObj(List<Map<String,String>>  list){
		
		Iterator<Map<String,String>>  it = list.iterator();
		List<Membership> listObjets = new ArrayList<Membership>();
		
		while(it.hasNext()){
			 
			Map<String,String> map = new HashMap<String, String>();
			map = it.next();
			listObjets.add(this.castToMembershipObj(map));
			
		}
		
		return listObjets;
	}
	
	public String getAssigned_date() {
		return assigned_date;
	}
	public void setAssigned_date(String assigned_date) {
		this.assigned_date = assigned_date;
	}
	public String getRole_id() {
		return role_id;
	}
	public void setRole_id(String role_id) {
		this.role_id = role_id;
	}
	public String getAssigned_by_user_id() {
		return assigned_by_user_id;
	}
	public void setAssigned_by_user_id(String assigned_by_user_id) {
		this.assigned_by_user_id = assigned_by_user_id;
	}
	public String getGroup_id() {
		return group_id;
	}
	public void setGroup_id(String group_id) {
		this.group_id = group_id;
	}
	public String getUser_id() {
		return user_id;
	}
	public void setUser_id(String user_id) {
		this.user_id = user_id;
	}
	@Override
	public String toString() {
		return "Membership [assigned_date=" + assigned_date + ", role_id="
				+ role_id + ", assigned_by_user_id=" + assigned_by_user_id
				+ ", group_id=" + group_id + ", user_id=" + user_id + "]";
	}
	
}
