package ve.gob.cnti.gestion.bonita.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ProcessDefinition {
	
	private String id;
	private String icon; 
	private String displayDescription;
	private String deploymentDate;
	private String description;
	private String activationState;
	private String name;
	private String deployedBy;
	private String displayName;
	private String last_update_date;
	private String configurationState;
	private String version;	
	
	/**
	 * @param list
	 * @return
	 * Este método recibe el Mapa String,String del response JSON y lo convierte en objeto ProcessDefinition
	 */
	public List<ProcessDefinition>  castToListProcessObj(List<Map<String,String>>  list){
		
		Iterator<Map<String,String>>  it = list.iterator();
		List<ProcessDefinition> listObjets = new ArrayList<ProcessDefinition>();
		
		while(it.hasNext()){
			 
			Map<String,String> map = new HashMap<String, String>();
			
			map = it.next();
			listObjets.add(this.castToProcessObj(map));
			
		}
		
		return listObjets;
	}
	
	public ProcessDefinition castToProcessObj(Map<String,String> map){
		
		String[] valores = new String[map.size()];
		
		int i = 0;
		for(String val: map.values()){
			valores[i]=val;
			i++;
		}
		
		ProcessDefinition pd = new ProcessDefinition(valores[0],valores[1],valores[2],valores[3],
				valores[4],valores[5],valores[6],valores[7], valores[8],valores[9], valores[10],
				valores[11]);
		
		return pd;
	}
		
	public ProcessDefinition() {
		
	}

	public ProcessDefinition(String id, String icon, String displayDescription,
			String deploymentDate, String description, String activationState,
			String name, String deployedBy, String displayName,
			String last_update_date, String configurationState, String version) {
		super();
		this.id = id;
		this.icon = icon;
		this.displayDescription = displayDescription;
		this.deploymentDate = deploymentDate;
		this.description = description;
		this.activationState = activationState;
		this.name = name;
		this.deployedBy = deployedBy;
		this.displayName = displayName;
		this.last_update_date = last_update_date;
		this.configurationState = configurationState;
		this.version = version;
	}
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getIcon() {
		return icon;
	}
	public void setIcon(String icon) {
		this.icon = icon;
	}
	public String getDisplayDescription() {
		return displayDescription;
	}
	public void setDisplayDescription(String displayDescription) {
		this.displayDescription = displayDescription;
	}
	public String getDeploymentDate() {
		return deploymentDate;
	}
	public void setDeploymentDate(String deploymentDate) {
		this.deploymentDate = deploymentDate;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getActivationState() {
		return activationState;
	}
	public void setActivationState(String activationState) {
		this.activationState = activationState;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getDeployedBy() {
		return deployedBy;
	}
	public void setDeployedBy(String deployedBy) {
		this.deployedBy = deployedBy;
	}
	public String getDisplayName() {
		return displayName;
	}
	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}
	public String getLast_update_date() {
		return last_update_date;
	}
	public void setLast_update_date(String last_update_date) {
		this.last_update_date = last_update_date;
	}
	public String getConfigurationState() {
		return configurationState;
	}
	public void setConfigurationState(String configurationState) {
		this.configurationState = configurationState;
	}
	public String getVersion() {
		return version;
	}
	public void setVersion(String version) {
		this.version = version;
	}

	@Override
	public String toString() {
		return "ProcessDefinition [id=" + id + ", icon=" + icon
				+ ", displayDescription=" + displayDescription
				+ ", deploymentDate=" + deploymentDate + ", description="
				+ description + ", activationState=" + activationState
				+ ", name=" + name + ", deployedBy=" + deployedBy
				+ ", displayName=" + displayName + ", last_update_date="
				+ last_update_date + ", configurationState="
				+ configurationState + ", version=" + version + "]";
	}	

}
