package ve.gob.cnti.gestion.bonita.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class Task {

	private String displayDescription;
	private String processId;
	private String state;
	private String type;
	private String assigned_id;
	private String assigned_date;
	private String id;
	private String executedBy;
	private String caseId;
	private String priority;
	private String description;
	private String actorId;
	private String name;
	private String reached_state_date;
	private String displayName;
	private String dueDate;
	private String last_update_date;
	
	public Task(String displayDescription, String processId, String state,
			String type, String assigned_id, String assigned_date, String id,
			String executedBy, String caseId, String priority,
			String description, String actorId, String name,
			String reached_state_date, String displayName, String dueDate,
			String last_update_date) {
		super();
		this.displayDescription = displayDescription;
		this.processId = processId;
		this.state = state;
		this.type = type;
		this.assigned_id = assigned_id;
		this.assigned_date = assigned_date;
		this.id = id;
		this.executedBy = executedBy;
		this.caseId = caseId;
		this.priority = priority;
		this.description = description;
		this.actorId = actorId;
		this.name = name;
		this.reached_state_date = reached_state_date;
		this.displayName = displayName;
		this.dueDate = dueDate;
		this.last_update_date = last_update_date;
	}

	public Task(){
	}

	/**
	 * 
	 * @param list
	 * @return Lista de Objetos Task
	 */
	public List<Task>  castToListTaskObj(List<Map<String,String>>  list){
		
		Iterator<Map<String,String>>  it = list.iterator();
		List<Task> listObjets = new ArrayList<Task>();
		
		while(it.hasNext()){
			 
			Map<String,String> map = new HashMap<String, String>();
			map = it.next();
			listObjets.add(this.castToTaskObj(map));
			
		}
		
		return listObjets;
	}
	
	
	/**
	 * 
	 * @param map
	 * @return
	 */
	public Task castToTaskObj(Map<String,String> map){
		
		String[] valores = new String[map.size()];
		
		int i = 0;
		for(String val: map.values()){
			valores[i]=val;			
			i++;
		}
	
		Task td = new Task(valores[0],valores[1],valores[2],valores[3],valores[4],valores[5],valores[6],valores[7],valores[8],valores[9],valores[10],valores[11],valores[12],valores[13],valores[14],valores[15],valores[16]);
		
		return td;
	}

	public String getDisplayDescription() {
		return displayDescription;
	}

	public void setDisplayDescription(String displayDescription) {
		this.displayDescription = displayDescription;
	}

	public String getProcessId() {
		return processId;
	}

	public void setProcessId(String processId) {
		this.processId = processId;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getAssigned_id() {
		return assigned_id;
	}

	public void setAssigned_id(String assigned_id) {
		this.assigned_id = assigned_id;
	}

	public String getAssigned_date() {
		return assigned_date;
	}

	public void setAssigned_date(String assigned_date) {
		this.assigned_date = assigned_date;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getExecutedBy() {
		return executedBy;
	}

	public void setExecutedBy(String executedBy) {
		this.executedBy = executedBy;
	}

	public String getCaseId() {
		return caseId;
	}

	public void setCaseId(String caseId) {
		this.caseId = caseId;
	}

	public String getPriority() {
		return priority;
	}

	public void setPriority(String priority) {
		this.priority = priority;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getActorId() {
		return actorId;
	}

	public void setActorId(String actorId) {
		this.actorId = actorId;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getReached_state_date() {
		return reached_state_date;
	}

	public void setReached_state_date(String reached_state_date) {
		this.reached_state_date = reached_state_date;
	}

	public String getDisplayName() {
		return displayName;
	}

	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}

	public String getDueDate() {
		return dueDate;
	}

	public void setDueDate(String dueDate) {
		this.dueDate = dueDate;
	}

	public String getLast_update_date() {
		return last_update_date;
	}

	public void setLast_update_date(String last_update_date) {
		this.last_update_date = last_update_date;
	}

	@Override
	public String toString() {
		return "Task [displayDescription=" + displayDescription
				+ ", processId=" + processId + ", state=" + state + ", type="
				+ type + ", assigned_id=" + assigned_id + ", assigned_date="
				+ assigned_date + ", id=" + id + ", executedBy=" + executedBy
				+ ", caseId=" + caseId + ", priority=" + priority
				+ ", description=" + description + ", actorId=" + actorId
				+ ", name=" + name + ", reached_state_date="
				+ reached_state_date + ", displayName=" + displayName
				+ ", dueDate=" + dueDate + ", last_update_date="
				+ last_update_date + "]";
	}
		
	
}
