package ve.gob.cnti.gestion.bonitaImpl;

import java.util.Iterator;
import java.util.List;

import org.bonitasoft.engine.api.ProcessAPI;
import org.bonitasoft.engine.platform.LoginException;
import org.bonitasoft.engine.session.APISession;

import ve.gob.cnti.gestion.bonita.bean.ActorMember;
import ve.gob.cnti.gestion.bonita.IActorMember;
import ve.gob.cnti.gestion.utils.FacesHandler;

public class ActorMemberImpl implements IActorMember{

	
	private SessionImpl sessionImpl = null;
	private FacesHandler facehandler = null;
	private List<ActorMember> listActorMember;
	
	public ActorMemberImpl(){
		
		this.sessionImpl = new SessionImpl();
		this.facehandler = new FacesHandler();
	}
	
	/**
	 * Este metodo retorna el mapeo de los, roles, grupos, o usuarios con el actor indicado
	 * @author José Francisco Luis Medina
	 * @param idActor
	 * @return
	 */
	@Override
	public List<ActorMember> listActorMembers(String idActor) {
		APISession apiSession = null;
		listActorMember = null;
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			List<org.bonitasoft.engine.bpm.actor.ActorMember> listEngineActorMember = processAPI
					.getActorMembers(Long.parseLong(idActor), 0, 100);
			Iterator<org.bonitasoft.engine.bpm.actor.ActorMember> ite = listEngineActorMember
					.iterator();
			while (ite.hasNext()) {
				listActorMember.add(this.beanActorMember2stringBeanActorMember(ite.next(),
								idActor));
			}

		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return listActorMember;
	}
	
	
	/**
	 * Este método recibe una instancia de una Relacion Actos-Miembros en los datos primitivos de BonitaEngine y devuelve un objeto ActorMember del bean ActorMember de la maquina de tramites basado en atributos exclusivamente Strings
	 * 
	 * TODO: es necesario que eun futuro no utlizar este metodo ya que los
	 * objetos se deben tratar con sus tipos de datos primitivos esta funcion
	 * recibe un objeto del tipo HumanTaskInstance con los tipos de datos
	 * originales de Bonita y crea un objeto tipo Task compuesto por Strings
	 * @author José Francisco Luis Medina
	 * @param {@link ActorMember} {@link String} 
	 * @return {@link ActorMember}
	 */
	private ActorMember beanActorMember2stringBeanActorMember(org.bonitasoft.engine.bpm.actor.ActorMember a, String actor_id) {
		ActorMember am = new ActorMember(
				Long.toString(a.getId()),
				actor_id,
				Long.toString(a.getRoleId()),
				Long.toString(a.getGroupId()),
				Long.toString(a.getUserId())
				);
		return am;
	}
	
	
}
