package ve.gob.cnti.gestion.bonitaImpl;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.http.HttpResponse;
import org.bonitasoft.engine.api.ProcessAPI;
import org.bonitasoft.engine.bpm.flownode.HumanTaskInstance;
import org.bonitasoft.engine.bpm.process.ProcessActivationException;
import org.bonitasoft.engine.bpm.process.ProcessDefinitionNotFoundException;
import org.bonitasoft.engine.bpm.process.ProcessDeploymentInfo;
import org.bonitasoft.engine.bpm.process.ProcessExecutionException;
import org.bonitasoft.engine.bpm.process.ProcessInstance;
import org.bonitasoft.engine.bpm.process.ProcessInstanceSearchDescriptor;
import org.bonitasoft.engine.exception.SearchException;
import org.bonitasoft.engine.platform.LoginException;
import org.bonitasoft.engine.search.Order;
import org.bonitasoft.engine.search.SearchOptionsBuilder;
import org.bonitasoft.engine.search.SearchResult;
import org.bonitasoft.engine.session.APISession;
import org.json.JSONException;

import ve.gob.cnti.gestion.bonita.ICase;
import ve.gob.cnti.gestion.bonita.IProcess;
import ve.gob.cnti.gestion.bonita.IUser;
import ve.gob.cnti.gestion.bonita.bean.Actor;
import ve.gob.cnti.gestion.bonita.bean.Case;
import ve.gob.cnti.gestion.bonita.bean.ProcessDefinition;
import ve.gob.cnti.gestion.bonita.bean.Task;
import ve.gob.cnti.gestion.utils.FacesHandler;
import ve.gob.cnti.gestion.utils.JsonManager;
import ve.gob.cnti.gestion.utils.PropertiesReader;

public class ProcessImpl implements IProcess{
	
	private SessionImpl sessionImpl = null;
	private JsonManager jManager = null;	
	private FacesHandler facehandler = null;
	private Actor actorDef = null;
	private ProcessAPI processAPI = null;
	private APISession apiSession = null;
	private Case caseObj = null;
	
	PropertiesReader properties = new PropertiesReader();		
    public String ADMIN_USERNAME = properties.bonitaProperties("ADMIN_USERNAME");
    public String ADMIN_PASSWORD = properties.bonitaProperties("ADMIN_PASSWORD");
	
	public ProcessImpl(){
		this.sessionImpl = new SessionImpl();
		this.jManager = new JsonManager();
		this.facehandler = new FacesHandler();
		this.actorDef = new Actor();
		this.caseObj = new Case();
	}
	
	
	@Override
	public ArrayList<ProcessDefinition> listProcess() throws JSONException, UnsupportedEncodingException, IllegalStateException, IOException {		
		ArrayList<ProcessDefinition> availableProc = new ArrayList<ProcessDefinition>();
		try {
			
			apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
			processAPI = sessionImpl.getProcessAPI(apiSession);
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
			SearchResult<ProcessDeploymentInfo> processList = processAPI.searchProcessDeploymentInfos(builder.done());
			
			for (ProcessDeploymentInfo proc : processList.getResult()) {
				availableProc.add(bonitaProcDef2StringProcDefBean(proc));
			}
			
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return availableProc;
	}
	
	
	
	

	
	@Override
	public ProcessDefinition getProcess(String idProc){
		
		org.bonitasoft.engine.bpm.process.ProcessDeploymentInfo process = null;
		ProcessDefinition procDef = null; 

		try {
			APISession apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			process = processAPI.getProcessDeploymentInfo(Long.parseLong(idProc));
			procDef = bonitaProcDef2StringProcDefBean(process);
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ProcessDefinitionNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return procDef;
	}
	
	/**
	 * TODO verificar la creacion de ese objeto caseBean
	 */
	@Override
	public Map<String,Object> startProcess(String idProc, String cedula){
		Map<String,Object> map=new HashMap<String, Object>();
		try {
			apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			System.out.println("-->Iniciando revision de caso imcompleto: "+"idProc: "+idProc+" Cedula: "+cedula);
			Map<String,Object> mp = validateNewCase(idProc, cedula);
			map.put("idCase", (Long) mp.get("idCase"));
			if ((Long) map.get("idCase")==0L) {
				ProcessInstance processInstance = processAPI.startProcess(Long.parseLong(idProc));
				caseObj = beanCase2stringBeanCase(processInstance);
				map.put("idCase", Long.parseLong(caseObj.getId()));
				map.put("userHasCase", mp.get("userHasCase"));
				System.out.println("--->userHasCase "+map.get("userHasCase"));
				System.out.println("--->Iniciando Nuevo Caso con id: " + caseObj.getId());
				return map; 
			} else {
				System.out.println("--->Reciclando caso de usuario: "+map.get("idCase"));
				map.put("userHasCase", mp.get("userHasCase"));
				map.put("idCase", mp.get("idCase"));
				System.out.println("---->userHasCase "+map.get("userHasCase"));
				return map; 
			}
			
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ProcessDefinitionNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ProcessActivationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ProcessExecutionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return map;
	}
	
	@Override
	public List<Actor> getActors(String idProcessDefinition){
		this.sessionImpl.startConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
		List<Actor> listActors = null;
		try {
			HttpResponse response = sessionImpl.executeGetRequest("/API/bpm/actor?p=0&c=10&f=process_id%3d"+idProcessDefinition);
			listActors = actorDef.castToListActorObj(jManager.arrayJSON2Map(response));
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		this.sessionImpl.stopConection();
		return listActors;
	}
	
	private ProcessDefinition bonitaProcDef2StringProcDefBean(org.bonitasoft.engine.bpm.process.ProcessDeploymentInfo process){
		ProcessDefinition procDef = new ProcessDefinition(
				String.valueOf(process.getProcessId()),
				process.getIconPath(),
				process.getDisplayDescription(),
				String.valueOf(process.getDeploymentDate()),
				process.getDescription(),
				String.valueOf(process.getActivationState()),
				process.getName(),
				String.valueOf(process.getDeployedBy()),
				process.getDisplayName(),
				String.valueOf(process.getLastUpdateDate()),
				String.valueOf(process.getConfigurationState()),
				process.getVersion()
				);
		
		return procDef;
	}
	
	/**
	 * Recibe un objeto del tipo ProcessInstance de Bonita y devuelve un objeto Case (bean del conector)
	 * TODO este método debe ser temporal ya que el ideal es que se manejen los objetos en sus tipos de datos primitivos
	 * @author José Francisco Luis Medina
	 * @param pi
	 * @return
	 */
	private Case beanCase2stringBeanCase(ProcessInstance pi){
		Case caseObj = new Case(
				String.valueOf(pi.getId()),
				String.valueOf(pi.getEndDate()),
				String.valueOf(pi.getStartDate()),
				pi.getState(),
				String.valueOf(pi.getRootProcessInstanceId()),
				String.valueOf(pi.getStartedBy()),
				String.valueOf(pi.getProcessDefinitionId()),
				String.valueOf(pi.getLastUpdate())
				);
		return caseObj;
	}
	
	/**
	 * Valida que el usuario en sesion no posea una instancia del proceso 
	 * abierta en la tarea indicada, la válidación se hace verificando que 
	 * una variable indicada (que sea crítica) no se encuentre vacía
	 * 
	 * @author José Francisco Luis Medina
	 * @return idCase
	 * */
	private Map<String,Object> validateNewCase(String process_definition_id, String cedula){
		
		SessionImpl sessionImpl = new SessionImpl();
		APISession apiSession = null;
		IUser user = new UserImpl();
		Map<String,Object> mp=new HashMap<String, Object>();
		mp.put("idCase", 0L);
		mp.put("userHasCase", false);
		try {
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 1000);
			builder.filter(ProcessInstanceSearchDescriptor.STARTED_BY, user.getIdByuserName(facehandler.getUserSession().get("user")));
			builder.filter(ProcessInstanceSearchDescriptor.PROCESS_DEFINITION_ID, process_definition_id);
			builder.filter(ProcessInstanceSearchDescriptor.STATE_ID, 1); // 1 -> Representa estado started (Abierto)
			builder.sort(ProcessInstanceSearchDescriptor.START_DATE, Order.DESC);
			SearchResult<ProcessInstance> pi = processAPI.searchProcessInstances(builder.done());
			
			for (ProcessInstance procInst : pi.getResult()) {				
				ICase caseImpl = new CaseImpl();
				List<Map<String, String>> vars = caseImpl.getCaseVarValues(String.valueOf(procInst.getId()));
				for (Map<String, String> map : vars) {
					if (map.get("name").equals("cedula")&&map.get("value").equals(cedula)) {
						System.out.println("-->Se identifica que usuario posee un caso abierto con número "+map.get("case_id"));
						mp.put("idCase", Long.parseLong(map.get("case_id")));
						mp.put("userHasCase", true);
						break;
					}
					if (map.get("name").equals("cedula")&&map.get("value").equals("null")) {
						System.out.println("-->Se identifica un caso huerfano con  número "+map.get("case_id"));
						mp.put("idCase", Long.parseLong(map.get("case_id")));
						break;
					}
				}
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
		return mp;
	}

		
}