package ve.gob.cnti.gestion.bonitaImpl;

import java.io.IOException;
import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Map;

import org.apache.http.HttpResponse;
import org.json.JSONException;

import ve.gob.cnti.gestion.bonita.ITask;
import ve.gob.cnti.gestion.bonita.IUser;
import ve.gob.cnti.gestion.bonita.bean.Task;
import ve.gob.cnti.gestion.utils.FacesHandler;
import ve.gob.cnti.gestion.utils.JsonManager;
import ve.gob.cnti.gestion.utils.PropertiesReader;

import org.bonitasoft.engine.api.ProcessAPI;
import org.bonitasoft.engine.bpm.flownode.ActivityInstanceNotFoundException;
import org.bonitasoft.engine.bpm.flownode.ArchivedHumanTaskInstance;
import org.bonitasoft.engine.bpm.flownode.ArchivedHumanTaskInstanceSearchDescriptor;
import org.bonitasoft.engine.bpm.flownode.FlowNodeExecutionException;
import org.bonitasoft.engine.bpm.flownode.HumanTaskInstance;
import org.bonitasoft.engine.bpm.flownode.HumanTaskInstanceSearchDescriptor;
import org.bonitasoft.engine.bpm.process.ArchivedProcessInstance;
import org.bonitasoft.engine.bpm.process.ArchivedProcessInstancesSearchDescriptor;
import org.bonitasoft.engine.bpm.process.ProcessInstanceNotFoundException;
import org.bonitasoft.engine.exception.SearchException;
import org.bonitasoft.engine.exception.UpdateException;
import org.bonitasoft.engine.platform.LoginException;
import org.bonitasoft.engine.search.Order;
import org.bonitasoft.engine.search.SearchOptionsBuilder;
import org.bonitasoft.engine.search.SearchResult;
import org.bonitasoft.engine.session.APISession;

public class TaskImpl implements ITask{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -408032355258814879L;
	/**
	 * 
	 */
	private SessionImpl sessionImpl = null;
	private JsonManager jManager = null;
	private Task taskDef = null;
	private FacesHandler facehandler = null;
	PropertiesReader properties = new PropertiesReader();		
    public String ADMIN_USERNAME = properties.bonitaProperties("ADMIN_USERNAME");
    public String ADMIN_PASSWORD = properties.bonitaProperties("ADMIN_PASSWORD");
	
	public TaskImpl() {
		sessionImpl = new SessionImpl();
		jManager = new JsonManager();
		taskDef = new Task();
		facehandler = new FacesHandler();
		
	}
	
	/**
	 * @author José Francisco Luis Medina
	 * @param idTask recibe el id de la tarea a obtener
	 * @return retorna un objeto del tipo Task
	 */
	@Override
//	public Task getTask(String idTask) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{
//		this.sessionImpl.startConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
//		HttpResponse response = sessionImpl.executeGetRequest("/API/bpm/humanTask/"+idTask+"?p=0");
//		return taskDef.castToTaskObj(jManager.objectJSON2Map(response));
//	}
	
	public Task getTask(String idTask){
		SessionImpl sessionImpl = new SessionImpl();
		APISession apiSession = null;
		Task task = new Task();
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			
			org.bonitasoft.engine.bpm.flownode.HumanTaskInstance engineTask = processAPI.getHumanTaskInstance(Long.parseLong(idTask));
			task = beanTask2stringBeanTask(engineTask);
			
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ActivityInstanceNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return task;
	}
	

	public Task getTaskbyCaseId(String id) {

		SessionImpl sessionImpl = new SessionImpl();
		APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);

		SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
		builder.filter(HumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID,
				id);
		Task task = null;
		// TODO: Suprimir este sleep, se coloco mientras se realiza la migración
		// del resto de los metodos de acces a Bonita
		try {
			Thread.sleep(1500);
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		try {
			SearchResult<HumanTaskInstance> humanTaskInstanceResults = processAPI
					.searchHumanTaskInstances(builder.done());
			for (HumanTaskInstance hti : humanTaskInstanceResults.getResult()) {

				task = beanTask2stringBeanTask(hti);
			}

		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
		processAPI = null;
		return task;
	}

	/**
	 * 
	 * Este método recibe una instancia de una tarea en los datos primitivos de BonitaEngine y devuelve un objeto Task del conector basado en atributos exclusivamente Strings
	 * 
	 * TODO: es necesario que eun futuro no utlizar este metodo ya que los
	 * objetos se deben tratar con sus tipos de datos primitivos esta funcion
	 * recibe un objeto del tipo HumanTaskInstance con los tipos de datos
	 * originales de Bonita y crea un objeto tipo Task compuesto por Strings
	 * @author José Francisco Luis Medina
	 * @param {@link HumanTaskInstance}
	 * @return {@link Task}
	 */
	private Task beanTask2stringBeanTask(HumanTaskInstance hti) {
		Task t = new Task(hti.getDisplayDescription(), 
				Long.toString(hti.getProcessDefinitionId()), 
				hti.getState(), 
				hti.getType().toString(), 
				Long.toString(hti.getAssigneeId()), 
				hti.getReachedStateDate().toString(), 
				Long.toString(hti.getId()),
				Long.toString(hti.getExecutedBy()), 
				Long.toString(hti.getParentContainerId()), 
				hti.getPriority().toString(),
				hti.getDescription(), 
				Long.toString(hti.getActorId()),
				hti.getName(), 
				hti.getReachedStateDate().toString(),
				hti.getDisplayName(), 
				hti.getExpectedEndDate().toString(), 
				hti.getLastUpdateDate().toString()
				);
		return t;
	}
	
	private Task beanTask2stringBeanTask(ArchivedHumanTaskInstance hti) {
		Task t = new Task(hti.getDisplayDescription(), 
				Long.toString(hti.getProcessDefinitionId()), 
				hti.getState(), 
				hti.getType().toString(), 
				Long.toString(hti.getAssigneeId()), 
				hti.getReachedStateDate().toString(), 
				Long.toString(hti.getId()),
				Long.toString(hti.getExecutedBy()), 
				Long.toString(hti.getParentContainerId()), 
				hti.getPriority().toString(),
				hti.getDescription(), 
				Long.toString(hti.getActorId()),
				hti.getName(), 
				hti.getReachedStateDate().toString(),
				hti.getDisplayName(), 
				hti.getExpectedEndDate().toString(), 
				hti.getLastUpdateDate().toString()
				);
		return t;
	}
		
	/**
	 * TODO fusionar este metodo con el metodo getAssignedTasks y filtrar a través del id como parametro
	 */
	@Override
	public List<Task> getUnassignedTasks() throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{
		this.sessionImpl.startConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
		HttpResponse response = sessionImpl.executeGetRequest("/API/bpm/humanTask?p=0&c=10&f=assigned_id%3d0");
		List<Task> tareas =  taskDef.castToListTaskObj(this.jManager.arrayJSON2Map(response));
		this.sessionImpl.stopConection();
		return tareas;
	}
	
	/**
	 * Devuelve las tareas asignadas a un usuario
	 * TODO fusionar este metodo con el metodo getUnassignedTasks y filtrar a través del id como parametro
	 */
	@Override
	public List<Task> getAssignedTasks(String userId){
		SessionImpl sessionImpl = new SessionImpl();
		List<Task> availableTasks = new ArrayList<Task>();
		APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
			builder.filter(HumanTaskInstanceSearchDescriptor.ASSIGNEE_ID, Long.parseLong(userId));

			SearchResult<HumanTaskInstance> humanTaskInstanceResults = processAPI
					.searchMyAvailableHumanTasks(Long.parseLong(userId, 10),
							builder.done());
			
			for (HumanTaskInstance humanTaskInstance : humanTaskInstanceResults
					.getResult()) {
				
				if (!humanTaskInstance.getName().matches("^_ASIG_.*")) {
					availableTasks.add(beanTask2stringBeanTask(humanTaskInstance));
				}
				
			}
		} catch (LoginException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
		return availableTasks;
	}
	
	/**
	 * @author José Francisco Luis Medina
	 * Recibe los id's de un usuario y una tarea y realiza la asignación de la misma
	 */
	@Override
	public void assignTask(String userId, String idTask){
		
		APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			processAPI.assignUserTask(Long.parseLong(idTask), Long.parseLong(userId));
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UpdateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
	}
	
	
	/**
	 * Libera la tarea indicada
	 * 
	 * @author José Francisco Luis Medina
	 */
	@Override
	public void releaseTask(String idTask){
		SessionImpl sessionImpl = new SessionImpl();
		APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			processAPI.releaseUserTask(Long.parseLong(idTask));
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ActivityInstanceNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UpdateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
	}
	
	
	@Override
	public void updateTaskVariables(String idTask, Map<String, Serializable> vars){

		APISession apiSession = null;
		ProcessAPI processAPI = null;
		
		try {
			apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
			processAPI = sessionImpl.getProcessAPI(apiSession);
			processAPI.updateActivityInstanceVariables(Long.parseLong(idTask), vars);
			sessionImpl.stopEngineConection(apiSession);
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UpdateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
	} 
	
	/**
	 * Completa una tarea permitiendo al flujo continuar su flujo, el O como parámetro indica que la tarea será
	 * completada en nombre del usuario que esta en session en el API
	 * 
	 * @author José Francisco Luis Medina
	 */
	@Override
	public void executeTask(String idTask){
		try {
			APISession apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			processAPI.executeFlowNode(0, Long.parseLong(idTask));
			sessionImpl.stopEngineConection(apiSession);
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FlowNodeExecutionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	/**
	 * Devuelve un listado de tareas disponibles para un usuario filtradas por
	 * proceso
	 * 
	 * @author José Francisco Luis Medina
	 * @param {@link String} idUser {@link idProcessDefinition}
	 * @return {@link List}<{@link Task}> availableTask
	 */
	@Override
	public List<Task> gesTasksAvailableForUser(String idUser) {
		
		SessionImpl sessionImpl = new SessionImpl();
		List<Task> availableTasks = new ArrayList<Task>();
		APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
			builder.filter(HumanTaskInstanceSearchDescriptor.ASSIGNEE_ID, 0L);

			SearchResult<HumanTaskInstance> humanTaskInstanceResults = processAPI
					.searchMyAvailableHumanTasks(Long.parseLong(idUser, 10),
							builder.done());

			for (HumanTaskInstance humanTaskInstance : humanTaskInstanceResults
					.getResult()) {
				
				if (!humanTaskInstance.getName().matches("^_ASIG_.*") && !humanTaskInstance.getName().matches("^_FALSE_.*")) {
					availableTasks.add(beanTask2stringBeanTask(humanTaskInstance));
				}
				
			}
		} catch (LoginException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
		return availableTasks;

	}

	/**
	 * Retorna las tareas de asignación activas para un usuario determinado
	 * @author José Francisco Luis Medina
	 */
	@Override
	public List<Task> getAssignmentTasks(String idUser){
		
		List<Task> availableTasks = new ArrayList<Task>();
		APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
			//builder.filter(HumanTaskInstanceSearchDescriptor.ASSIGNEE_ID, "^Revision.*");
			//builder.filter(HumanTaskInstanceSearchDescriptor.NAME,"^_ASSIGNMENT_.*");
			
			SearchResult<HumanTaskInstance> humanTaskInstanceResults = processAPI
					.searchMyAvailableHumanTasks(Long.parseLong(idUser, 10),
							builder.done());
			IUser user = new UserImpl();
			for (HumanTaskInstance humanTaskInstance : humanTaskInstanceResults
					.getResult()) {
				if (humanTaskInstance.getName().matches("^_ASIG_TRUE_.*")
						|| (humanTaskInstance.getName()
								.matches("^_ASIG_FALSE_.*"))
						&& String.valueOf(humanTaskInstance.getAssigneeId())
								.contentEquals(
										user.getIdByuserName(facehandler
												.getUserSession().get("user")))) {
					// if (humanTaskInstance.getName().matches("^_ASIG_.*")) {
					availableTasks
							.add(beanTask2stringBeanTask(humanTaskInstance));
				}
			}
		} catch (LoginException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
		return availableTasks;
	} 
	
	

	
	/**
	 * Devuelve el id de la tarea de ejecución que depende de una tarea de asignación
	 * @author José Francisco Luis Medina
	 *  
	 */
	@Override
	public String getDependingTask(String idMasterTask){
		
		
		Task dependingTask = new Task();
		Task masterTask = new Task();
		APISession apiSession = null;

		try {
			apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			masterTask = getTask(idMasterTask);
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
			builder.filter(HumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID,masterTask.getCaseId());
			// TODO: Suprimir este sleep, se coloco mientras se realiza la migración
			// del resto de los metodos de acces a Bonita
//			Thread.sleep(1500);
			SearchResult<HumanTaskInstance> humanTaskInstanceResults = processAPI
					.searchHumanTaskInstances(builder.done());
			for (HumanTaskInstance hti : humanTaskInstanceResults.getResult()) {
				
				if (masterTask.getName().matches("_ASIG_TRUE_"+hti.getName()) || masterTask.getName().matches("_ASIG_FALSE_"+hti.getName())){
					//masterTask.getName().matches("_ASIG_TRUE"+hti.getName())
					dependingTask = beanTask2stringBeanTask(hti);
				
				}
				
			}

		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		sessionImpl.stopEngineConection(apiSession);
		return dependingTask.getId();
	}
	
	/**
	 * Asigna la tarea indicada al usuario que inicio el proceso
	 * @author José Francisco Luis Medina
	 * @param idCase
	 * @param idTask
	 */
	@Override
	public void assignToStarter(String idCase){
		
		APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			Long idUserStarter = processAPI.getProcessInstance(Long.parseLong(idCase)).getStartedBy();
			processAPI.assignUserTask(Long.parseLong(getTaskbyCaseId(idCase).getId()), idUserStarter);
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UpdateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ProcessInstanceNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
		
	}
	
	/**
	 *  TODO Este metodo se utiliza para obtener un listado de las tareas por las que ha pasado una solicitud
	 *  @author Yamil Orozco
	 *  @param idCase
	 *  @return allActitivies (list(Task))
	 *     Contiene una lista con las tareas que se han ejecutado y donde se encuentra la solicitud
	 */
	
	public List<Task> getAllHumanActivities(String idCase) {
		SessionImpl sessionImpl = new SessionImpl();
		APISession apiSession=null;
		ProcessAPI processAPI=null;
		
		try {
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);
			processAPI = sessionImpl.getProcessAPI(apiSession);
		} catch (LoginException e1) {
		// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}		
		
		SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
		builder.filter(ArchivedHumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID,Long.parseLong(idCase));
		builder.sort(ArchivedHumanTaskInstanceSearchDescriptor.REACHED_STATE_DATE, Order.ASC);
		SearchResult<ArchivedHumanTaskInstance> humanTaskHistoryInstanceResults=null;
		try {
			humanTaskHistoryInstanceResults = processAPI
					.searchArchivedHumanTasks(builder.done());
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		
		List<Task> allActitivies = new ArrayList<Task>();
		Task taksHuman=null;
		
		
		for (ArchivedHumanTaskInstance hti : humanTaskHistoryInstanceResults.getResult()) {			
			taksHuman=beanTask2stringBeanTask(hti);
			if (!hti.getState().equals("completed")){				
				taksHuman.setState("En curso");
			}else{
				taksHuman.setState("Completado");
			}
			allActitivies.add(taksHuman);		
			
			
		}
		
		builder = new SearchOptionsBuilder(0, 10000);
		builder.filter(HumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID,Long.parseLong(idCase));
		SearchResult<HumanTaskInstance> humanTaskInstanceResults=null;
		try {
			humanTaskInstanceResults = processAPI
					.searchHumanTaskInstances(builder.done());
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
		taksHuman=null;
		for (HumanTaskInstance hti : humanTaskInstanceResults.getResult()) {	
			taksHuman=beanTask2stringBeanTask(hti);
			if (!hti.getState().equals("completed")){
				
				taksHuman.setState("En curso");
			}else{
				taksHuman.setState("Completado");
			}
			allActitivies.add(taksHuman);	
		
		}
		
		/*Collections.sort(allActitivies, new Comparator<Task>() {			
			
			@Override
			public int compare(Task p1, Task p2) {
				return p1.getId().compareTo(p2.getId());
				
			}
		});*/
		
		
		sessionImpl.stopEngineConection(apiSession);
		
		return allActitivies;				
		
	}
	
	/*
	 * Obtiene la lista de las tareas de los procesos completados
	 * 
	 * */
	
	public List<Task> getTaskCompleted(String idCase) {
		SessionImpl sessionImpl = new SessionImpl();
		APISession apiSession=null;
		ProcessAPI processAPI=null;
		
		try {
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);
			processAPI = sessionImpl.getProcessAPI(apiSession);
		} catch (LoginException e1) {
		// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}		
		
		SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
		builder.filter(ArchivedHumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID,idCase);	
		builder.sort(ArchivedHumanTaskInstanceSearchDescriptor.REACHED_STATE_DATE, Order.ASC);
		SearchResult<ArchivedHumanTaskInstance> humanTaskHistoryInstanceResults=null;
		try {
			humanTaskHistoryInstanceResults = processAPI
					.searchArchivedHumanTasks(builder.done());
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		
		List<Task> allActitivies = new ArrayList<Task>();
		Task taksHuman=null;
		
		
		for (ArchivedHumanTaskInstance hti : humanTaskHistoryInstanceResults.getResult()) {			
			//System.out.println("tarea"+hti);
			taksHuman=beanTask2stringBeanTask(hti);
			taksHuman.setState("Completado");
			
			allActitivies.add(taksHuman);		
			
			
		}
		
		sessionImpl.stopEngineConection(apiSession);
		
		return allActitivies;				
		
	} 
	
	
	
	
	public Task getTaskbyCaseIdHistory(String id) {

		SessionImpl sessionImpl = new SessionImpl();
		APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(facehandler
					.getUserSession().get("user"), facehandler.getUserSession()
					.get("pass"));
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);

		SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
		builder.filter(ArchivedHumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID,Long.parseLong(id));
		Task task = null;
		// TODO: Suprimir este sleep, se coloco mientras se realiza la migración
		// del resto de los metodos de acces a Bonita
		try {
			Thread.sleep(1500);
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		try {
			SearchResult<ArchivedHumanTaskInstance> humanTaskHistoryInstanceResults = processAPI
					.searchArchivedHumanTasks(builder.done());
			for (ArchivedHumanTaskInstance hti :humanTaskHistoryInstanceResults.getResult()) {

				task = beanTask2stringBeanTask(hti);
			}

		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sessionImpl.stopEngineConection(apiSession);
		processAPI = null;
		return task;
	}
	
}
