package ve.gob.cnti.gestion.controller;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

@ManagedBean(name = "navigationController", eager = true)
@SessionScoped
public class NavigationController {

	/** Barra de menu de la interfaz de ciudadano
	 * @author Joaquin Pereira
	 * @param Id de la vista a desplegar
	 * @return El sitio donde se encuentra la vista a mostrar
	 */
	public String menuCiudadanoBar(int a){
		switch (a) {
		case 1:
			return "/views/interfazportalciudadano/view.xhtml?faces-redirect=true";
		case 2:
			return "/views/interfazportalciudadano/listCases.xhtml?faces-redirect=true";	
		case 3:
			return "/views/interfazportalciudadano/listTasks.xhtml?faces-redirect=true";
		default:
			break;
		}		
		return "/views/interfazportalciudadano/view.xhtml?faces-redirect=true";
	}
	
	/** Barra de menu de la interfaz de Funcionario
	 * @author Joaquin Pereira
	 * @param Id de la vista a desplegar
	 * @return El sitio donde se encuentra la vista a mostrar
	 */
	public String menuFuncionarioBar(int a){
		switch (a) {
		case 1:
			return "/views/interfazportalfuncionario/view.xhtml?faces-redirect=true";
		case 2:
			return "/views/interfazportalfuncionario/tasks/listAssignedTasks.xhtml?faces-redirect=true";	
		case 4:
			return "/views/layout/consultas/buscarPorCI.xhtml?faces-redirect=true";	
		case 5:
			return "/views/layout/consultas/buscarPorParametros.xhtml?faces-redirect=true";	
		case 6:
			return "/views/interfazportalfuncionario/updatePass.xhtml?faces-redirect=true";
		default:
			return "/views/interfazportalfuncionario/view.xhtml?faces-redirect=true";
		}		
	}	
	
	/** Barra de menu de la interfaz de Funcionario Asignador
	 * @author Joaquin Pereira
	 * @param Id de la vista a desplegar
	 * @return El sitio donde se encuentra la vista a mostrar
	 */
	public String menuFuncionarioAsignadorBar(int a){
		switch (a) {
		case 1:
			return "/views/interfazportalfuncionarioasignador/view.xhtml?faces-redirect=true";
		case 2:
			return "/views/interfazportalfuncionarioasignador/tasks/listPendingTask.xhtml?faces-redirect=true";
		case 3:
			return "/views/interfazportalfuncionarioasignador/tasks/listAssignedTasks.xhtml?faces-redirect=true";
		case 4:
			return "/views/layout/consultas/buscarPorCI.xhtml?faces-redirect=true";	
		case 5:
			return "/views/layout/consultas/buscarPorParametros.xhtml?faces-redirect=true";		
		default:
			return "/views/interfazportalfuncionarioasignador/view.xhtml?faces-redirect=true";
		}		
	}
	
	/** Barra de menu de la interfaz de Funcionario Sin Privilegios
	 * @author Joaquin Pereira
	 * @param Id de la vista a desplegar
	 * @return El sitio donde se encuentra la vista a mostrar
	 */
	public String menuFuncionarioSinPrivilegiosBar(int a){
		switch (a) {
		case 1:
			return "/views/interfazportalfuncionariosinprivilegios/view.xhtml?faces-redirect=true";		
		case 4:
			return "/views/layout/consultas/buscarPorCI.xhtml?faces-redirect=true";	
		case 5:
			return "/views/layout/consultas/buscarPorParametros.xhtml?faces-redirect=true";		
		default:
			return "/views/interfazportalfuncionariosinprivilegios/view.xhtml?faces-redirect=true";
		}		
	}
	
}
