package ve.gob.cnti.gestion.controller;


import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;

import org.json.JSONException;

//TODO migracion bandeja
//import com.liferay.portal.kernel.exception.PortalException; //migracion bandeja
//import com.liferay.portal.kernel.exception.SystemException; //migracion bandeja


import ve.gob.cnti.gestion.bonita.IController;
import ve.gob.cnti.gestion.bonita.IProcess;
import ve.gob.cnti.gestion.bonita.bean.ProcessDefinition;
import ve.gob.cnti.gestion.bonitaImpl.CaseImpl;
import ve.gob.cnti.gestion.bonitaImpl.ControllerImpl;
import ve.gob.cnti.gestion.bonitaImpl.ProcessImpl;
import ve.gob.cnti.gestion.utils.FacesHandler;
import ve.gob.cnti.gestion.utils.PropertiesReader;
import ve.gob.cnti.gestion.utils.Utils;

@SuppressWarnings("unused")
@ManagedBean(name = "ProcessController", eager = true)
@RequestScoped
public class ProcessController{
	
	private Utils utils = new Utils(); 	
	private IProcess process = new ProcessImpl();
	private IController iController = new ControllerImpl();
	private List<ProcessDefinition> deployed_processes;
	private ProcessDefinition proceso = new ProcessDefinition();
	private FacesHandler facesHandler = new FacesHandler();
	private String urlView;
	private String idTask;
	private String idCase;
	private PropertiesReader reader = new PropertiesReader();
	
	//TODO migracion bandeja -> se eliminan dos throws (PortalException, SystemException)
	public String getProcess(String idProcess) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		proceso = process.getProcess(idProcess);		
		return "/views/interfazportalciudadano/processDefinition.xhtml";
	}
	
	public String getProcessName(String processId) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		proceso = process.getProcess(processId);
		return proceso.getName();
	}
	
	public String getProcessDisplayName(String processId) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		proceso = process.getProcess(processId);		
		return proceso.getDescription();
	}
	
	public String getProcessDisplayNameByIdCase(String IdCase) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		proceso = process.getProcess(new CasesController().getCase(IdCase).getProcessDefinitionId());
		return proceso.getDescription();
	}
	
	public String getProcessDisplayNameByIdCaseInHistory(String IdCase) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		proceso = process.getProcess(new CaseImpl().getArchivedCase(IdCase).getProcessDefinitionId());
		return proceso.getDescription();
	}
	
	//TODO migracion bandeja -> se eliminan dos throws (PortalException, SystemException)
	public List<ProcessDefinition> getDeployed_processes() throws JSONException, UnsupportedEncodingException, IllegalStateException, IOException {
		
		File dir = new File(new Utils().getRealPath("/views/tramites/"));
		String[] archivos = dir.list();
		
		List<ProcessDefinition> listBPM = process.listProcess();
		
		if(archivos!=null){
			Map<String,String> procesosParseados = new HashMap<String, String>();
			for(String archivo : archivos)							
				procesosParseados.put(archivo, archivo);
			
			List<ProcessDefinition> list = new ArrayList<ProcessDefinition>();
			for(ProcessDefinition pc : listBPM){
				if(procesosParseados.containsKey(pc.getName()))
					list.add(pc);
			}
			
			
			Collections.sort(list, new Comparator<ProcessDefinition>(){
				    public int compare(ProcessDefinition s1, ProcessDefinition s2) {
				        return s1.getDescription().compareToIgnoreCase(s2.getDescription());
				    }
				});	
			
			
			return list;
			
		}
		
		Collections.sort(listBPM, new Comparator<ProcessDefinition>(){
		    public int compare(ProcessDefinition s1, ProcessDefinition s2) {
		        return s1.getDescription().compareToIgnoreCase(s2.getDescription());
		    }
		});
		
		
		return 	listBPM;
	}

	public ProcessDefinition getProceso() throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException {		
		return proceso;
	}

	public void setProceso(ProcessDefinition proceso) {
		this.proceso = proceso;
	}

	public String getUrlView() {
		return urlView;
	}

	public void setUrlView(String urlView) {
		this.urlView = urlView;
	}

	public String getIdTask() {
		return idTask;
	}

	public void setIdTask(String idTask) {
		this.idTask = idTask;
	}

	public String getIdCase() {
		return idCase;
	}

	public void setIdCase(String idCase) {
		this.idCase = idCase;
	}	

}
