package ve.gob.cnti.gestion.controller;

import java.io.IOException;
import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.bean.SessionScoped;
import javax.faces.bean.ViewScoped;

import org.apache.log4j.pattern.IntegerPatternConverter;
import org.json.JSONException;

import ve.gob.cnti.gestion.bonita.IController;
import ve.gob.cnti.gestion.bonita.ITask;
import ve.gob.cnti.gestion.bonita.IUser;
import ve.gob.cnti.gestion.bonita.bean.DatosBasicosNatural;
import ve.gob.cnti.gestion.bonita.bean.Task;
import ve.gob.cnti.gestion.bonitaImpl.ControllerImpl;
import ve.gob.cnti.gestion.bonitaImpl.TaskImpl;
import ve.gob.cnti.gestion.bonitaImpl.UserImpl;
import ve.gob.cnti.gestion.controller.beans.TaskHelper;
import ve.gob.cnti.gestion.utils.FacesHandler;
import ve.gob.cnti.gestion.utils.PropertiesReader;
import ve.gob.cnti.gestion.utils.Utils;

@SuppressWarnings("unused")
@ManagedBean(name = "TaskController", eager = true)
@SessionScoped
public class TaskController implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private List<Task> listTask = new ArrayList<Task>();
	
	private List<TaskHelper> listTaskHelper = new ArrayList<TaskHelper>();
	
	private Task task = new Task();
	private DatosBasicosNatural dbn = new DatosBasicosNatural();
	private FacesHandler facesHandler = new FacesHandler();
	private Utils utils = new Utils();
	private ITask iTask = new TaskImpl();
	private IUser iUser = new UserImpl();
	private IController iController = new ControllerImpl(); 
	private PropertiesReader reader = new PropertiesReader();
	private static final String dirViews = "/views/tramites/";
	private Map<String, String> idsDependingTask = new HashMap<String, String>();
	private String isStartCase = null;
	private String isHistoryConsult = null;
		
	public List<TaskHelper>  getListAssignedTask() throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		
		List<Task> listTask = iTask.getAssignedTasks(iUser.getIdByuserName(facesHandler.getUserSession().get("user")));
		List<TaskHelper> listTaskHelper = new ArrayList<TaskHelper>();
		for(Task t:listTask){
			TaskHelper th = new TaskHelper();
			th.setId(t.getId());
			th.setIdCase(t.getCaseId());
			th.setActivityPending(t.getDisplayName());
			th.setProcessName(new ProcessController().getProcessName(t.getProcessId()));
			th.setProcessDisplayName(new ProcessController().getProcessDisplayName(t.getProcessId()));
			th.setStartDate(new CasesController().getStartCase(t.getCaseId()));
			th.setName(t.getName());
			listTaskHelper.add(th);
		}
		
		return listTaskHelper;
	}
		
	public List<TaskHelper> getListPendingTask() throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{	
		
		List<Task> listTask = iController.gesTasksAvailableForUser(iUser.getIdByuserName(facesHandler.getUserSession().get("user")));
		List<TaskHelper> listTaskHelper = new ArrayList<TaskHelper>();
		for(Task t:listTask){
			TaskHelper th = new TaskHelper();
			th.setId(t.getId());
			th.setIdCase(t.getCaseId());
			th.setActivityPending(t.getDisplayName());
			th.setProcessName(new ProcessController().getProcessName(t.getProcessId()));
			th.setProcessDisplayName(new ProcessController().getProcessDisplayName(t.getProcessId()));
			th.setStartDate(new CasesController().getStartCase(t.getCaseId()));
			th.setName(t.getName());
			listTaskHelper.add(th);
		}
		
		return listTaskHelper;
	}
	
	public List<Task> getListByAssigningTask() throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{	
		listTask = iTask.getAssignmentTasks(iUser.getIdByuserName(facesHandler.getUserSession().get("user")));
		for(Task t : listTask){
			idsDependingTask.put(t.getId(), iTask.getDependingTask(t.getId()));
		}
		return listTask;
	}
	
	public String getIdDependingTask(String id_masterTask) throws UnsupportedEncodingException, IOException{
		return iTask.getDependingTask(id_masterTask);
	}
	
	
	public String getObjTask(String id) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		task = iTask.getTask(id);		
		return "/views/interfazportalfuncionario/tasks/task.xhtml";		
	}
	
	public String assignedTask(String idTask) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{
		iTask.assignTask(iUser.getIdByuserName(facesHandler.getUserSession().get("user")), idTask);
		return "/views/interfazportalfuncionario/view.xhtml";
	}
	
	public String executeTask(String idTask,String taskName,String processName) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		taskName = taskName.replaceAll(" ", "");
		task = iTask.getTask(idTask);
		return dirViews+processName+"/forms/"+taskName+"/"+taskName+".xhtml?faces-redirect=true";
	}
	
	public String takeAndPerformTask(String idTask,String taskName,String processName) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{		
		iTask.assignTask(iUser.getIdByuserName(facesHandler.getUserSession().get("user")), idTask);
		isHistoryConsult=null;
		taskName = taskName.replaceAll(" ", "");	
		task = iTask.getTask(idTask);
		return dirViews+processName+"/forms/"+taskName+"/"+taskName+".xhtml?faces-redirect=true";
	}
	
	public String caseConsult(String idTask,String taskName,String processName) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{	
		isHistoryConsult=null;
		task = iTask.getTask(idTask);
		return dirViews+processName+"/forms/consultaDeCaso/consultaDeCaso.xhtml";
	}
	
	public String caseConsult(String idCase,String processName) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException, InterruptedException{	
		isHistoryConsult=null;
		task = iTask.getTaskbyCaseId(idCase);
		return dirViews+processName+"/forms/consultaDeCaso/consultaDeCaso.xhtml?faces-redirect=true";
		
	}
	
	public String caseConsultTab(String processName) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{	
		
		return dirViews+processName+"/forms/consultaDeCaso/tabs/tabConsultaDeCaso.xhtml";
	}
	
	public String consultaDeCaso(String idCase,String processName){			
		task=iTask.getTaskbyCaseIdHistory(idCase);
		isHistoryConsult = "true";
		return dirViews+processName+"/forms/consultaDeCaso/consultaDeCaso.xhtml";
	}
	
	/**TODO
	 * Iniciar Caso
	 * Obetener Id del caso mediante su objeto
	 * Con la id del caso obtener la tarea pendiente para:
	 * 			==>Asignar la tarea al usuario
	 * 			==>devolver el string clave que resuelve la navegación en la vista
	 * @throws InterruptedException 
	 */
	public String starCase(String idProcess ) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException, InterruptedException{		
//		String idProcess =  facesHandler.getParam("idProcess");
		System.out.println("idProcess ===> "+idProcess);
		Map<String, String> params = iController.initCase(idProcess, "");
		String tramite = params.get("nameProc");
		String view = params.get("nameTask").replaceAll(" ", "");	 
		task = iTask.getTask(params.get("idTask"));
		isStartCase="true";
		System.out.println(task.toString());
		return dirViews+tramite+"/forms/"+view+"/"+view+".xhtml";
	}
	
	public String starCase(String idProcess ,DatosBasicosNatural db) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException, InterruptedException{		
		Map<String, String> params = iController.initCase(idProcess, db.getCedula());
		task = iTask.getTask(params.get("idTask"));		
		if(params.get("userHasCase").contentEquals("true")){
			isStartCase=null;
			System.out.println("el usuario tiene caso");
			new Utils().setMessageToView(reader.getI18nProperty("tamiteAbierto"), 3);
			return caseConsult(task.getCaseId(),params.get("nameProc"));
		}
		System.out.println("el usuario no tiene caso");
		String tramite = params.get("nameProc");
		String view = params.get("nameTask").replaceAll(" ", "");	
		isStartCase="true";		
		this.dbn = db;
		return dirViews+tramite+"/forms/"+view+"/"+view+".xhtml";
	}
	
	public Object setValuesFromIO(Object objeto, DatosBasicosNatural dbn) throws NoSuchFieldException, SecurityException, NumberFormatException, IllegalArgumentException, IllegalAccessException, ParseException{
		
		Field atributo = objeto.getClass().getDeclaredField("cedula");atributo.setAccessible(true);
		atributo.setInt(objeto, Integer.parseInt(dbn.getCedula()));
		
		atributo = objeto.getClass().getDeclaredField("nombre");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getPrimerNombre()+" "+dbn.getSegundoNombre()));
		
		atributo = objeto.getClass().getDeclaredField("apellido");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getPrimerApellido() + " " + dbn.getSegundoApellido()));
		
		atributo = objeto.getClass().getDeclaredField("f_nacimiento");atributo.setAccessible(true);
		atributo.set(objeto, (new SimpleDateFormat("dd/MM/yyyy").parse(dbn.getF_nacimiento())));
		
		atributo = objeto.getClass().getDeclaredField("edo_civil");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getEdo_civil()));
		
		atributo = objeto.getClass().getDeclaredField("nacionalidad");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getNacionalidad()));
		
		atributo = objeto.getClass().getDeclaredField("sexo");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getSexo()));

		atributo = objeto.getClass().getDeclaredField("pais");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getPais()));
		
		atributo = objeto.getClass().getDeclaredField("estado");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getEstado()));
		
		atributo = objeto.getClass().getDeclaredField("municipio");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getMunicipio()));
				
		atributo = objeto.getClass().getDeclaredField("parroquia");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getParroquia()));
		
		atributo = objeto.getClass().getDeclaredField("direccion");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getDireccion()));
		
		atributo = objeto.getClass().getDeclaredField("tlf_local");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getTlf_local()));
		
		atributo = objeto.getClass().getDeclaredField("tlf_movil");atributo.setAccessible(true);
		atributo.set(objeto, (dbn.getTlf_movil()));
		
		atributo = objeto.getClass().getDeclaredField("email");atributo.setAccessible(true);
		atributo.set(objeto, (new FacesHandler().getUserSession().get("email")));
		
		return objeto;
	}
		
	public List<Task> getListHistoryTask(String idCase) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{	
		return iTask.getAllHumanActivities(idCase);
	}
	
	public List<Task> getTaskProcessCompleted(String idCase) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{	
		return iTask.getTaskCompleted(idCase);
	}
	
	public Task getTask() {
		return this.task;
	}
	public void setTask(Task task) {
		this.task = task;
	}
	
	public List<Task> getListTask() {
		return this.listTask;
	}
	public void setListTask(List<Task> listTask) {
		this.listTask = listTask;
	}

	public Utils getUtils() {
		return utils;
	}

	public void setUtils(Utils utils) {
		this.utils = utils;
	}

	public Map<String, String> getIdsDependingTask() {
		return idsDependingTask;
	}

	public void setIdsDependingTask(Map<String, String> idsDependingTask) {
		this.idsDependingTask = idsDependingTask;
	}

	public String getIsStartCase() {
		return isStartCase;
	}

	public void setIsStartCase(String isStartCase) {
		this.isStartCase = isStartCase;
	}

	public DatosBasicosNatural getDbn() {
		return dbn;
	}

	public void setDbn(DatosBasicosNatural dbn) {
		this.dbn = dbn;
	}

	public String getIsHistoryConsult() {
		return isHistoryConsult;
	}

	public void setIsHistoryConsult(String isHistoryConsult) {
		this.isHistoryConsult = isHistoryConsult;
	}

	public List<TaskHelper> getListTaskHelper() {
		return listTaskHelper;
	}

	public void setListTaskHelper(List<TaskHelper> listTaskHelper) {
		this.listTaskHelper = listTaskHelper;
	}

}
