package ve.gob.cnti.gestion.controller;

import java.util.List;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;

import ve.gob.cnti.gestion.bonita.bean.Actor;
import ve.gob.cnti.gestion.bonita.bean.User;
import ve.gob.cnti.gestion.bonitaImpl.TaskImpl;
import ve.gob.cnti.gestion.bonitaImpl.UserImpl;
import ve.gob.cnti.gestion.bonita.ITask;
import ve.gob.cnti.gestion.bonita.IUser;
import ve.gob.cnti.gestion.utils.FacesHandler;

@SuppressWarnings("unused")
@ManagedBean(name = "UserController", eager = true)
public class UserController {
	
	
	private List<User> usersAvailablesForTask;
	private IUser iUser;
	private String idUser;
	private String idDependingTask;
	private ITask task;
	
	public UserController() {
		iUser = new UserImpl();
		task = new TaskImpl();
	}
	
	public void assigningUserTask(String idTask,String idMasterTask){		
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Tarea Asignada", ""));		
		task.assignTask(idUser, idTask);
		task.assignTask(iUser.getIdByuserName(new FacesHandler().getUserSession().get("user")), idMasterTask);
		task.executeTask(idMasterTask);
	}

	public List<User> getUsersAvailablesForTask(String id) {
		return iUser.getUsersAvailablesForTask(id);
	}
	
	public String getUserName(String id){
		System.out.println(id);
		if(Long.parseLong(id)>0)
			return iUser.getUsernameById(Long.parseLong(id));
		else
			return "--";
	}

	public void setUsersAvailablesForTask(List<User> usersAvailablesForTask) {
		this.usersAvailablesForTask = usersAvailablesForTask;
	}

	public String getIdUser() {
		return idUser;
	}

	public void setIdUser(String idUser) {
		this.idUser = idUser;
	}

	public String getIdDependingTask() {
		return idDependingTask;
	}

	public void setIdDependingTask(String idDependingTask) {
		this.idDependingTask = idDependingTask;
	}
	
	
}
