package ve.gob.cnti.gestion.io;

import java.io.IOException;
import java.io.Serializable;
import java.io.UnsupportedEncodingException;

import java.util.Map;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import org.json.JSONException;

import org.primefaces.context.RequestContext;

import ve.gob.cnti.gestion.bonita.IIO;
import ve.gob.cnti.gestion.bonita.bean.DatosBasicosNatural;
import ve.gob.cnti.gestion.controller.TaskController;
import ve.gob.cnti.gestion.utils.FacesHandler;
import ve.gob.cnti.gestion.utils.Utils;
@ManagedBean(name = "ioConsult", eager = true)
@SessionScoped
public class IOConsult implements Serializable {

	public void cancel() {
		this.idProcess = "";
		this.cedula="";
		this.nacionalidad="";
		RequestContext.getCurrentInstance().execute("PF('datosDialogo').hide();");
	}

	public String getCedula() {
		return cedula;
	}

	public String getDatos() {
		return datos;
	}

	public DatosBasicosNatural getDb() {
		return db;
	}

	public String getIdProcess() {
		return idProcess;
	}

	public String getNacionalidad() {
		return nacionalidad;
	}

	public void obtenerDatos() {
		if (!this.validateData()) {
			IIO io = new IOImpl();
			this.db = io.getDataNatural(nacionalidad, cedula);

			if (this.db.getCedula() == null) {
				new Utils().setMessageToView("Error la cédula "+nacionalidad+" - "+cedula+" no esta registrada", 1);
				RequestContext.getCurrentInstance().execute("PF('blockUI2').hide();");
				RequestContext.getCurrentInstance().execute("PF('miDialogoVar').show();");
			}else {
				this.datos = db.getCedula();
				RequestContext.getCurrentInstance().execute("PF('miDialogoVar').hide();");
				RequestContext.getCurrentInstance().execute("PF('datosDialogo').show();");
			}
		}else {
			RequestContext.getCurrentInstance().execute("PF('blockUI2').hide();");
			RequestContext.getCurrentInstance().execute("PF('miDialogoVar').show();");
		}
	}

	public void obtenerFormulario(String idProcess) {
		this.idProcess = idProcess;
		this.cedula="";
		this.nacionalidad="";
		//RequestContext.getCurrentInstance().execute("PF('miDialogoVar').show();");
		//TODO CONSULTAR SERVICIO
		try {
			IIO io = new IOImpl();
			FacesHandler faces=new FacesHandler();
			Map<String, String> user=faces.getUserSession();
		    this.db = io.getDataCiudadano(user.get("user").toUpperCase());
			//new TaskController().starCase(idProcess, db);
			RequestContext.getCurrentInstance().execute("PF('datosDialogo').show();");
		} catch (IllegalStateException e) {

			// TODO Auto-generated catch block

			e.printStackTrace();
		} catch (JSONException e) {

			// TODO Auto-generated catch block

			e.printStackTrace();
		}
	}

	public void setCedula(String cedula) {
		this.cedula = cedula;
	}

	public void setDatos(String datos) {
		this.datos = datos;
	}

	public void setDb(DatosBasicosNatural db) {
		this.db = db;
	}

	public void setIdProcess(String idProcess) {
		this.idProcess = idProcess;
	}

	public void setNacionalidad(String nacionalidad) {
		this.nacionalidad = nacionalidad;
	}

	public boolean validateData() {
		boolean validar = false;

		if (this.cedula == null || this.nacionalidad == null) {
			new Utils().setMessageToView("Error Todos los campos son obligatorios", 1);
			validar = true;
		}

		if (this.cedula!=null) {
			try {
				Integer.parseInt(this.cedula);
			} catch (Exception e) {
				new Utils().setMessageToView("Error el campo cédula debe solo tener números", 1);
				validar = true;
			}

			if (this.cedula.length()>9) {
				new Utils().setMessageToView("Error el campo cédula debe estar conformado por un máximo 9 carácteres", 1);
				validar = true;
			}
		}

		if (this.nacionalidad!=null) {
			if (! (this.nacionalidad.contentEquals("V") || this.nacionalidad.contentEquals("E")) ) {
				new Utils().setMessageToView("Error el campo nacionalidad debe solo poseer el valor V o E", 1);
				validar = true;
			}
		}

		return validar;

	}

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	private String cedula;
	private String datos;
	private DatosBasicosNatural db = new DatosBasicosNatural();
	private String idProcess;
	private String nacionalidad;

}