package ve.gob.cnti.gestion.jms;


import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;


import org.apache.commons.io.IOUtils;
import org.bonitasoft.engine.api.ProcessAPI;
import org.bonitasoft.engine.bpm.data.ArchivedDataInstance;
import org.bonitasoft.engine.bpm.data.DataDefinition;
import org.bonitasoft.engine.bpm.flownode.ArchivedHumanTaskInstance;
import org.bonitasoft.engine.bpm.flownode.ArchivedHumanTaskInstanceSearchDescriptor;
import org.bonitasoft.engine.bpm.flownode.HumanTaskInstance;
import org.bonitasoft.engine.bpm.flownode.HumanTaskInstanceSearchDescriptor;
import org.bonitasoft.engine.bpm.flownode.impl.FlowElementContainerDefinition;
import org.bonitasoft.engine.bpm.process.ArchivedProcessInstance;
import org.bonitasoft.engine.bpm.process.ArchivedProcessInstancesSearchDescriptor;
import org.bonitasoft.engine.bpm.process.DesignProcessDefinition;
import org.bonitasoft.engine.bpm.process.ProcessDefinition;
import org.bonitasoft.engine.bpm.process.ProcessDefinitionNotFoundException;
import org.bonitasoft.engine.bpm.process.ProcessInstance;
import org.bonitasoft.engine.bpm.process.ProcessInstanceSearchDescriptor;
import org.bonitasoft.engine.exception.SearchException;
import org.bonitasoft.engine.expression.Expression;
import org.bonitasoft.engine.platform.LoginException;
import org.bonitasoft.engine.search.Order;
import org.bonitasoft.engine.search.SearchOptionsBuilder;
import org.bonitasoft.engine.search.SearchResult;
import org.bonitasoft.engine.session.APISession;

import ve.gob.cnti.gestion.alfresco.ICmisController;
import ve.gob.cnti.gestion.alfresco.impl.AlfrescoLoadFiles;
import ve.gob.cnti.gestion.alfresco.impl.ContentStream;
import ve.gob.cnti.gestion.bonitaImpl.SessionImpl;
import ve.gob.cnti.gestion.utils.EncryptSha256;
import ve.gob.cnti.gestion.utils.FacesHandler;
import ve.gob.cnti.gestion.utils.PropertiesReader;
import ve.gob.cnti.gestion.utils.Utils;

public class SenderJMS implements ISenderJMS {
	
	//private static final Logger log = Logger.getLogger(SenderJMS.class.getName());
	
	PropertiesReader properties = new PropertiesReader();
    public String ADMIN_USERNAME = properties.bonitaProperties("ADMIN_USERNAME");
    public String ADMIN_PASSWORD = properties.bonitaProperties("ADMIN_PASSWORD");
    
    SessionImpl sessionImpl = new SessionImpl();
	APISession apiSession=null;
	ProcessAPI processAPI=null;
	ProcessInstance processInstance=null;
	ArchivedProcessInstance archivedProcessInstance=null;
	IConnectionJMS connectionJMS=null;
	List<ArchivedDataInstance> listArchivedDataInstance=null;
	List<ArchivedHumanTaskInstance>  listArchivedHumanTaskInstance=null;
	ArchivedHumanTaskInstance archivedHumanTaskInstance=null;
	HumanTaskInstance humanTaskInstance=null;
	ProcessDefinition processDefinition=null;	
	private static final Logger log = Logger.getLogger(SenderJMS.class.getName());
    
    public SenderJMS(){
    	
    }
	@Override
	public  void sendProcessRegistry(String processInstanceId) {
		// TODO Auto-generated method stub
		
		
		Utils utils=new Utils();
		log.info("enviando el mensaje sobre un proceso finalizado");
		
		try {
			
			connectionJMS=new ConnectionJMS();
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);
			processAPI = sessionImpl.getProcessAPI(apiSession);
		} catch (LoginException e1) {
		// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}		
		try {	
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 100000);
			builder.filter(ArchivedProcessInstancesSearchDescriptor.SOURCE_OBJECT_ID, processInstanceId);
			builder.filter(ArchivedProcessInstancesSearchDescriptor.STATE_ID,6);			
			SearchResult<ArchivedProcessInstance> archivedProcessInstanceResults=processAPI.searchArchivedProcessInstances(builder.done());;
			List<ArchivedProcessInstance> archivedProcessInstanceList=archivedProcessInstanceResults.getResult();
			archivedProcessInstance=archivedProcessInstanceList.get(0);
			log.info(archivedProcessInstance.getState());
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch(IndexOutOfBoundsException e){
			log.info("No se encuentra el proceso finalizado");
		}catch(Exception e){
			e.printStackTrace();
			
		}		
		if(archivedProcessInstance!=null && archivedProcessInstance.getState().equals("completed")){
			//listArchivedDataInstance=processAPI.getArchivedProcessDataInstances(Long.valueOf(processInstanceId), 0, 100000);
			
			List<ArchivedDataInstance>	archivesData=processAPI.getArchivedProcessDataInstances(Long.valueOf(processInstanceId), 0, 100000);
			ArchivedDataInstance data=null;
			Iterator<ArchivedDataInstance> archivesDataIterator=archivesData.iterator();
			Map<String,String> register=new HashMap<String,String>();
			
			while(archivesDataIterator.hasNext()){
				data=(ArchivedDataInstance)archivesDataIterator.next();	
				if(data.getClassName().equals("java.util.Date")&&data.getValue()!=null)
					register.put(data.getName(), utils.getSympleFormattedDate("yyyy-MM-dd", "EEE MMM dd kk:mm:ss z yyy",data.getValue().toString()
							.replace("<?xml version=\"1.0\" ?><date>", "").
							replace("</date>", "").trim()).toString());
				else
					register.put(data.getName(), String.valueOf(data.getValue()));				
				
				
				
			}			
			
		    register.put("id_instancia", processInstanceId);		   
			register.put("lastupdate",utils.getSympleFormattedDate("yyyy-MM-dd", "EEE MMM dd kk:mm:ss z yyy",archivedProcessInstance.getLastUpdate().toString()));			
			register.put("tramite",archivedProcessInstance.getName());		
			register.put("description",archivedProcessInstance.getDescription());		
			register.put("f_solicitud",utils.getSympleFormattedDate("yyyy-MM-dd", "EEE MMM dd kk:mm:ss z yyy",String.valueOf(archivedProcessInstance.getStartDate())));	
			
			// data de prueba se debe sustituir en el modelado por las variables transversales			
			
			/*register.put("f_solicitud","2015-01-30");		//traer de la instancia de proceso
			register.put("cedula","10009973");			
			register.put("nombre","Yamil");		
			register.put("apellido","Orozco");		
			register.put("sexo","M");			
			register.put("pais","Venezuela");			
			register.put("estado","caracas");
			register.put("ciudad","caracas");
			register.put("f_nacimiento","1976-05-30");*/
			
			
			///
			
			connectionJMS.openConnection(connectionJMS.getDEFAULT_PROCESS_REGISTRY_DESTINATION());			
		    connectionJMS.setMapMessage(register);			
		    connectionJMS.sendInfo();
		    connectionJMS.closeConection();
		}
		
		sessionImpl.stopEngineConection(apiSession);
		
		
	}

	@Override
	public void sendUsersActivities(String processInstanceId) {
		// TODO Auto-generated method stub
		    
		
		try {			
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);
			processAPI = sessionImpl.getProcessAPI(apiSession);
		} catch (LoginException e1) {
		// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}		
		try {	
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
			builder.filter(ArchivedHumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID, processInstanceId)
			.filter(ArchivedHumanTaskInstanceSearchDescriptor.STATE_NAME,"completed").sort(ArchivedHumanTaskInstanceSearchDescriptor.REACHED_STATE_DATE,Order.DESC);			
			SearchResult<ArchivedHumanTaskInstance> archivedTaskProcessInstanceResults=processAPI.searchArchivedHumanTasks(builder.done());
			List<ArchivedHumanTaskInstance> archivedTaskProcessInstanceList=archivedTaskProcessInstanceResults.getResult();
			archivedHumanTaskInstance=archivedTaskProcessInstanceList.get(0);
			
			log.info("enviando mensaje sobre las actividades ejecutadas y en curso");			
			
			List<ArchivedDataInstance>	archivesData=processAPI.getArchivedProcessDataInstances(Long.valueOf(processInstanceId), 0, 10000);
			ArchivedDataInstance data=null;
			Iterator<ArchivedDataInstance> archivesDataIterator=archivesData.iterator();
			Map<String,String> menssagesFrondEnd=new HashMap<String,String>();
			try{
				builder = new SearchOptionsBuilder(0, 100000);
				builder.filter(ProcessInstanceSearchDescriptor.ID, processInstanceId);						
				SearchResult<ProcessInstance> processInstanceResults=processAPI.searchProcessInstances(builder.done());;
				List<ProcessInstance> processInstanceList=processInstanceResults.getResult();
				processInstance=processInstanceList.get(0);
				menssagesFrondEnd.put("f_solicitud",String.valueOf(processInstance.getStartDate()));
				log.info("fecha solicitud"+processInstance.getStartDate());
			}catch(IndexOutOfBoundsException e){
				builder = new SearchOptionsBuilder(0, 100000);
				builder.filter(ArchivedProcessInstancesSearchDescriptor.SOURCE_OBJECT_ID, processInstanceId);
				SearchResult<ArchivedProcessInstance> archivedProcessInstanceResults=processAPI.searchArchivedProcessInstances(builder.done());;
				List<ArchivedProcessInstance> archivedProcessInstanceList=archivedProcessInstanceResults.getResult();
				archivedProcessInstance=archivedProcessInstanceList.get(0);
				menssagesFrondEnd.put("f_solicitud",String.valueOf(archivedProcessInstance.getStartDate()));
				log.info("fecha solicitud"+archivedProcessInstance.getStartDate());		
			}
			
			while(archivesDataIterator.hasNext()){
				data=(ArchivedDataInstance)archivesDataIterator.next();
				menssagesFrondEnd.put(data.getName(), String.valueOf(data.getValue()));
				//log.info("nombre="+data.getName()+"value="+String.valueOf(data.getValue()));
			}		
			
			processDefinition=processAPI.getProcessDefinition(archivedHumanTaskInstance.getProcessDefinitionId());
			String descriptionProcess = new String(processDefinition.getDescription().getBytes("UTF-8"), "UTF-8");
			
		
			
			if(descriptionProcess==null||descriptionProcess==""){
				descriptionProcess="N/A";
			}
			String descriptionTask = new String(archivedHumanTaskInstance.getDisplayName().getBytes("UTF-8"), "UTF-8");
			
			if(descriptionTask==null||descriptionTask==""){
				descriptionTask="N/A";
			}
			
			/*if(archivedHumanTaskInstance.getName().equals("revision"))				
				menssagesFrondEnd.put("revision", menssagesFrondEnd.get("revision"));
			else
				menssagesFrondEnd.put("revision", "N/A");*/
				
			menssagesFrondEnd.put("id",processInstanceId);
			menssagesFrondEnd.put("taskId", String.valueOf(archivedHumanTaskInstance.getId()));
			menssagesFrondEnd.put("processName", processDefinition.getName());
			menssagesFrondEnd.put("processDescription", descriptionProcess);
			menssagesFrondEnd.put("taskName", archivedHumanTaskInstance.getName());
			menssagesFrondEnd.put("taskDescription",descriptionTask);
			menssagesFrondEnd.put("lastupdate", String.valueOf(archivedHumanTaskInstance.getLastUpdateDate()));

			connectionJMS=new ConnectionJMS();
			connectionJMS.openConnection(connectionJMS.getDEFAULT_USERS_ACTIVITIES_DESTINATION());
			connectionJMS.setMapMessage(menssagesFrondEnd);			
			connectionJMS.sendInfo();
			connectionJMS.closeConection();	
		//essionImpl.stopEngineConection(apiSession);
			
		} catch (SearchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch(IndexOutOfBoundsException e){
			log.info("No se encuentra la actividad de la instancia de proceso suministrada");
		}catch(Exception e){
			e.printStackTrace();
			
		}	
		sessionImpl.stopEngineConection(apiSession);
		
	}

	@Override
	public void sendEmailFuncionarioGenerico(String processInstanceId) {
		// TODO Auto-generated method stub
		
		
		log.info("enviando mensaje sobre los datos del correo a enviar al funcionario");
		connectionJMS=new ConnectionJMS();
		Map<String,String> register=new HashMap<String,String>();
		
		try {			
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);
			processAPI = sessionImpl.getProcessAPI(apiSession);
			SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 10000);
			builder.filter(HumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID, processInstanceId)
			.sort(HumanTaskInstanceSearchDescriptor.REACHED_STATE_DATE,Order.DESC);			
			SearchResult<HumanTaskInstance> processTaskInstanceResults=processAPI.searchHumanTaskInstances(builder.done());
			List<HumanTaskInstance> processTaskInstanceList=processTaskInstanceResults.getResult();
			Iterator<HumanTaskInstance> processTaskInstanceIterator=processTaskInstanceList.iterator();
			
			while(processTaskInstanceIterator.hasNext()){				
				humanTaskInstance=(HumanTaskInstance)processTaskInstanceIterator.next();				
				if(humanTaskInstance.getName().toLowerCase().equals("sgi")){
					break;
				}
			}
			
			if(humanTaskInstance!=null){
			//log.info("human task"+humanTaskInstance.getName());		
				processDefinition=processAPI.getProcessDefinition(humanTaskInstance.getProcessDefinitionId());
				
				builder = new SearchOptionsBuilder(0, 100000);
				builder.filter(ProcessInstanceSearchDescriptor.ID, processInstanceId);						
				SearchResult<ProcessInstance> processInstanceResults=processAPI.searchProcessInstances(builder.done());;
				List<ProcessInstance> processInstanceList=processInstanceResults.getResult();
				processInstance=processInstanceList.get(0);
				//og.info(processInstance.getState());	
			}
		
		} catch (LoginException e1) {
		// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}
		//System.out.println(processDefinition.getId());
		//log.info(humanTaskInstance.getName());
		if(humanTaskInstance!=null&&humanTaskInstance.getName().toLowerCase().equals("sgi")){
		    log.info("entro a la tarea SGI");
			List<ArchivedDataInstance>	archivesData=processAPI.getArchivedProcessDataInstances(Long.valueOf(processInstanceId), 0, 10000);
			ArchivedDataInstance data=null;
			Iterator<ArchivedDataInstance> archivesDataIterator=archivesData.iterator();
			while(archivesDataIterator.hasNext()){
				data=(ArchivedDataInstance)archivesDataIterator.next();
				
				if((data.getName().indexOf("_FILE")>=0&& data.getValue()!=null&&!data.getValue().toString().equals(""))){
						register.put(data.getName(), String.valueOf(data.getValue()));
				}else if(!(data.getName().indexOf("_FILE_")>=0)){
					register.put(data.getName(), String.valueOf(data.getValue()));
				}
				/*if(data.getName().equals("f_nacimiento")){
					register.put(data.getName(), utils.getSympleFormattedDate("yyyy-MM-dd", "EEE MMM dd kk:mm:ss z yyy",data.getValue().toString()));
				}	*/								
				//log.info("name "+data.getName()+" type "+data.getValue()+" date"+data.getArchiveDate());
			}
			
			register.put("id_tramite",processInstanceId);
			register.put("tipo_tramite",processDefinition.getName());
			register.put("taskName",humanTaskInstance.getName());
			register.put("taskId",String.valueOf(humanTaskInstance.getId()));		
			register.put("f_solicitud",String.valueOf(processInstance.getStartDate()));		
			long timeStamp=System.currentTimeMillis();
			EncryptSha256 encrypt=new EncryptSha256();
			String hash=encrypt.encript(String.valueOf(timeStamp));
			register.put("hash",hash.trim());
			
			FacesHandler faces=new FacesHandler();
			Map<String,String> user=faces.getUserSession();
			String emailNotificador=user.get("email");
			//log.info("el email del notificador"+emailNotificador);
			register.put("emailNotificador",emailNotificador);
			if(humanTaskInstance.getDescription()==null||humanTaskInstance.getDescription().equals("")){
				register.put("taskDescription","N\\A");
			}else{
				register.put("taskDescription",humanTaskInstance.getDisplayName());
							
			}
		
			
			if(processDefinition.getDescription()==null||processDefinition.equals("")){
				register.put("descripcion_tramite","N\\A");
			}else{
				register.put("descripcion_tramite",processDefinition.getDescription());
							
			}
			
			
			
			// data de prueba se debe sustituir en el modelado por las variables transversales
			/*
			register.put("f_solicitud","2015-01-30");
			register.put("cedula","10009973");			
			register.put("nombre","Yamil");		
			register.put("apellido","Orozco");		
			register.put("email","yjorozco@cnti.gob.ve");
			register.put("sexo","M");			
			register.put("pais","Venezuela");			
			register.put("estado","caracas");
			register.put("ciudad","caracas");
			register.put("f_nacimiento","1976-05-30");
			
			//
			
			register.put("emailSGI","yjorozco@cnti.gob.ve"); //cambiar por la nomenclatura del documento
			register.put("emailFuncionario","yjorozco@cnti.gob.ve");*/
			
			//
			
			connectionJMS.openConnection(connectionJMS.getDEFAULT_EMAIL_DESTINATION());		
			connectionJMS.setMapMessage(register);		
			connectionJMS.sendInfo();
			connectionJMS.closeConection();	
		}
		sessionImpl.stopEngineConection(apiSession);
		
	}
	@Override
	public void sendResponse(String processInstanceId) {
		
		// TODO Auto-generated method stub
		Map<String,String> register=new HashMap<String,String>();
		SearchOptionsBuilder builder=null;
		try {
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);
			processAPI = sessionImpl.getProcessAPI(apiSession);
			builder = new SearchOptionsBuilder(0, 100000);
			builder.filter(ArchivedProcessInstancesSearchDescriptor.SOURCE_OBJECT_ID, processInstanceId);
			builder.filter(ArchivedProcessInstancesSearchDescriptor.STATE_ID,6);			
			SearchResult<ArchivedProcessInstance> archivedProcessInstanceResults;
			archivedProcessInstanceResults = processAPI.searchArchivedProcessInstances(builder.done());	
			List<ArchivedProcessInstance> archivedProcessInstanceList=archivedProcessInstanceResults.getResult();
			archivedProcessInstance=archivedProcessInstanceList.get(0);
		} catch(IndexOutOfBoundsException e){
			log.info("No se encuentra el proceso finalizado");
		}catch (SearchException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		} catch (LoginException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		
		if(archivedProcessInstance!=null && archivedProcessInstance.getState().equals("completed")){
			
		
			try {			
	
				builder = new SearchOptionsBuilder(0, 10000);
				builder.filter(ArchivedHumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID, processInstanceId);
				builder.sort(ArchivedHumanTaskInstanceSearchDescriptor.REACHED_STATE_DATE,Order.DESC);			
				SearchResult<ArchivedHumanTaskInstance> archivedTaskProcessInstanceResults=processAPI.searchArchivedHumanTasks(builder.done());
				List<ArchivedHumanTaskInstance> archivedTaskProcessInstanceList=archivedTaskProcessInstanceResults.getResult();
				archivedHumanTaskInstance=archivedTaskProcessInstanceList.get(0);
				//log.info("human task"+archivedHumanTaskInstance.getName());
				processDefinition=processAPI.getProcessDefinition(archivedHumanTaskInstance.getProcessDefinitionId());
				
				
				
			}catch (Exception e){
				e.printStackTrace();
			}	
	
			String descriptionProcess=processDefinition.getDescription();
			if(descriptionProcess==null||descriptionProcess==""){
				descriptionProcess="N/A";
			}
			String descriptionTask=archivedHumanTaskInstance.getDescription();
			if(descriptionTask==null||descriptionTask==""){
				descriptionTask="N/A";
			}
			
			if(archivedHumanTaskInstance.getDescription()==null||archivedHumanTaskInstance.getDescription().equals("")){
				register.put("taskDescription","N\\A");
			}else{
				register.put("taskDescription",archivedHumanTaskInstance.getDisplayName());
							
			}
			
			/*if(archivedHumanTaskInstance.getName().equals("revision"))				
				register.put("revision", "aprobado");
			else
				register.put("revision", "N/A");		*/
			
			if(processDefinition.getDescription()==null||processDefinition.getDescription().equals("")){
				register.put("processDescription","N\\A");
			}else{
				register.put("processDescription",processDefinition.getDescription());
							
			}		
			
			register.put("tramite",processInstanceId);
			register.put("processName",processDefinition.getName());
			register.put("taskName",archivedHumanTaskInstance.getName());
			register.put("taskId",String.valueOf(archivedHumanTaskInstance.getId()));			
						
			List<ArchivedDataInstance>	archivesData=processAPI.getArchivedProcessDataInstances(Long.valueOf(processInstanceId), 0, 10000);
			ArchivedDataInstance data=null;
			Iterator<ArchivedDataInstance> archivesDataIterator=archivesData.iterator();
			Utils utils=new Utils();
			while(archivesDataIterator.hasNext()){
				data=(ArchivedDataInstance)archivesDataIterator.next();
				
				if(data.getName().equals("cedula")||data.getName().equals("email")||
				   data.getName().equals("nombre")||data.getName().equals("causasDevolucion")||data.getName().equals("revision")||data.getName().equals("apellido")||
				   (data.getName().indexOf("_FILE_decision")>=0&& data.getValue()!=null)){
					register.put(data.getName(), String.valueOf(data.getValue()));
				}
				if(data.getName().equals("f_cita")&&data.getValue()!=null){
					register.put(data.getName(), utils.getSympleFormattedDate("dd-MM-yyyy", "EEE MMM dd kk:mm:ss z yyy",data.getValue().toString()));
				}		
				
				//log.info("name "+data.getName()+" type "+data.getValue()+" date"+data.getArchiveDate());
			}
			register.put("f_solicitud",String.valueOf(utils.getSympleFormattedDate("dd-MM-yyyy", "EEE MMM dd kk:mm:ss z yyy",archivedProcessInstance.getStartDate().toString())));	
			;			
			
			//ICmisController alfresco=new AlfrescoLoadFiles();
			//ContentStream documentoStream=alfresco.getDocument(register.get("_FILE_Planilla"));
			//InputStream inputStream=documentoStream.getStream();
			//register.put("_FILE_Planilla_Nombre",documentoStream.getFileName());
			
			
			//// eliminar ///
			/*InputStream inputStream=null;
			try {
				inputStream = new FileInputStream("/home/emendez/Descargas/resultados.pdf");
			} catch (FileNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			register.put("_FILE_Planilla_Nombre","resultados.pdf"); //cambiar por el documento
			register.put("cedula","10.009.973");
			register.put("nombre","yamil");
			register.put("apellido","Orozco");
			register.put("f_solicitud","10-05-2006");
			register.put("f_cita","10-05-2006");
			register.put("tipo","cita"); //verificar 
			register.put("email","yjorozco@cnti.gob.ve");*/
			//////////////////////
			connectionJMS=new ConnectionJMS();
			connectionJMS.openConnection(connectionJMS.getDEFAULT_PROCESS_REGISTRY_RESPONSE());		
			
			log.info(register.get("_FILE_decision")+"decision");
			if(register.get("f_cita")==null&&register.get("_FILE_decision")!=null&&!register.get("_FILE_decision").equals("[]")){
				ICmisController alfresco=new AlfrescoLoadFiles();
				ContentStream content=alfresco.getDocument(register.get("_FILE_decision").replace("[", "").replace("]", ""));
				byte[] documentoByte=null;
				InputStream inputStream=content.getStream();
				try {
					documentoByte = IOUtils.toByteArray(inputStream);
					
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				register.put("_FILE_Planilla_Nombre",content.getFileName());
				connectionJMS.setMapMessage("Bytes_FILE_Planilla", documentoByte);
			}
			connectionJMS.setMapMessage(register);
			connectionJMS.sendInfo();
			connectionJMS.closeConection();	
		}
		sessionImpl.stopEngineConection(apiSession);

	}
	

}
