package ve.gob.cnti.gestion.user;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;

import ve.gob.cnti.gestion.bonita.IUser;
import ve.gob.cnti.gestion.bonitaImpl.UserImpl;
import ve.gob.cnti.gestion.utils.PropertiesReader;

@ManagedBean(name = "UpdatePassword", eager = true)
@SessionScoped
public class UpdatePassword {

	 private String userId;
	 private String newPassword;
	 private String confirm;
	 
	

	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	public String getNewPassword() {
		return newPassword;
	}

	public void setNewPassword(String newPassword) {
		this.newPassword = newPassword;
	}

	public String getConfirm() {
		return confirm;
	}

	public void setConfirm(String confirm) {
		this.confirm = confirm;
	}

	@Override
	public String toString() {
		return "UpdatePassword [userId=" + userId + ", newPassword=" + newPassword + ", confirm=" + confirm + "]";
	}
	

	public void updatePassword(String newPassword, String confirm){
		
		try {
			String username = (String) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("userId");
			IUser iu = new UserImpl();
			iu.updateUserPassword(username, newPassword);
			String message = new PropertiesReader().getI18nProperty("successUpdatePass");
			FacesMessage msg = new FacesMessage(message);
			msg.setSeverity(FacesMessage.SEVERITY_INFO);
			FacesContext.getCurrentInstance().addMessage(null, msg);
		} catch (Exception e) {
			String message = new PropertiesReader().getI18nProperty("errorUpdatePass");
			FacesMessage msg = new FacesMessage(message);
			msg.setSeverity(FacesMessage.SEVERITY_ERROR);
			FacesContext.getCurrentInstance().addMessage(null, msg);
		}
		
		
	}
	
}
