package ve.gob.cnti.gestion.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.http.HttpResponse;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

public class JsonManager {

	/**
	 * 
	 * @param {@link HttpResponse}
	 * @return {@link ArrayList}<{@link Map}<{@link String}, {@link String}>>
	 * @throws UnsupportedEncodingException
	 * @throws IllegalStateException
	 * @throws IOException
	 * @throws JSONException
	 */
	public  ArrayList<Map<String, String>> arrayJSON2Map(HttpResponse response) throws UnsupportedEncodingException, IllegalStateException, IOException, JSONException{		
		JSONArray jArray = getArrayList(response);
		ArrayList<Map<String, String>> list = new ArrayList<Map<String, String>>();
		
		for (int i = 0; i < jArray.length(); i++) {
			//Iterator<?> ite = getKeys(response); 
			Iterator<?> ite = jArray.getJSONObject(i).keys(); //Obtener las Keys
			Map<String, String> jObjectElement = new HashMap<String, String>();
			
			  while (ite.hasNext()){
	            String key = (String)ite.next();
	            jObjectElement.put(key, jArray.getJSONObject(i).getString(key));	           
			  }
			  
			  list.add(jObjectElement);

		}
	return list;	
	}
	
	public Map<String,String> objectJSON2Map(HttpResponse response) throws UnsupportedEncodingException, IllegalStateException, JSONException, IOException{
		
		JSONObject jObject = this.getObject(response);
		Iterator<?> ite = jObject.keys(); //Obtener las Keys
		Map<String, String> resultMap = new HashMap<String, String>();
		
		while (ite.hasNext()){
			String key = (String)ite.next();
			resultMap.put(key, jObject.getString(key));
		}
		
		return resultMap;
	}
	
//	private Iterator<?> getKeys(HttpResponse response) throws JSONException, IOException{
//		
//		JSONArray jArray = getArrayList(response);
//		Iterator<?> ite = jArray.getJSONObject(0).keys();
//		
//		return ite;
//	}
	
	
	private JSONArray getArrayList(HttpResponse response) throws UnsupportedEncodingException, IllegalStateException, IOException, JSONException{
		
		BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
		StringBuilder builder = new StringBuilder();
		for (String line = null; (line = reader.readLine()) != null;) {
			builder.append(line).append("\n");
		}
		
		JSONTokener tokener = new JSONTokener(builder.toString());
		JSONArray jArray = new JSONArray(tokener);
		
		return jArray;
	}
	
	private JSONObject getObject(HttpResponse response) throws UnsupportedEncodingException, IllegalStateException, IOException, JSONException{
		
		BufferedReader reader = new BufferedReader(new InputStreamReader(response.getEntity().getContent(), "UTF-8"));
		StringBuilder builder = new StringBuilder();
		for (String line = null; (line = reader.readLine()) != null;) {
		    builder.append(line).append("\n");
		}
		
		JSONTokener tokener = new JSONTokener(builder.toString());
		JSONObject jObject = new JSONObject(tokener);
		
		return jObject;
	}
	
	public JSONObject listMap2payload(List<Map<String,Object>> list){
		JSONArray jsonArray = new JSONArray();
	
		for (int i = 0; i < list.size(); i++) {
		    Map<String,Object> map = list.get(i);

		    Iterator<?> it = map.entrySet().iterator();
		    
		    while (it.hasNext()) {
		    	@SuppressWarnings("rawtypes")
				Map.Entry pairs = (Map.Entry)it.next();
		        JSONObject jsonObj= new JSONObject();
			    jsonObj.put("name", pairs.getKey().toString());
			    jsonObj.put("value", pairs.getValue());
			    jsonArray.put(jsonObj);
		        //it.remove(); // avoids a ConcurrentModificationException
		    }
		    
		    it=null;
		    
		}
			
		JSONObject payload = new JSONObject();
		payload.put("variables", jsonArray);
		System.out.println(payload.toString());
	
		return payload;
	}
	
	
}
