package ve.gob.cnti.gestion.utils;

import java.util.Properties;

import javax.naming.Context;
import javax.naming.NamingEnumeration;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.SearchControls;

public class LdapManager {
	
	public static boolean authenticateJndi(String username, String password) throws Exception{
		PropertiesReader pr = new PropertiesReader();
		String initial_context_factory = pr.getLdapProperty("INITIAL_CONTEXT_FACTORY");
		String ldap_host = pr.getLdapProperty("PROVIDER_URL");
		String base_dn = pr.getLdapProperty("BASE_DN");
		
	    Properties props = new Properties();
	    props.put(Context.INITIAL_CONTEXT_FACTORY, initial_context_factory);
	    props.put(Context.PROVIDER_URL, ldap_host);
	    //props.put(Context.SECURITY_PRINCIPAL, "cn=admin,dc=gob,dc=ve");//adminuser - User with special priviledge, dn user
	    //props.put(Context.SECURITY_CREDENTIALS, "mysecret");//dn user password


	    InitialDirContext context = new InitialDirContext(props);

	    SearchControls ctrls = new SearchControls();
	    ctrls.setReturningAttributes(new String[] { "givenName", "sn","memberOf" });
	    ctrls.setSearchScope(SearchControls.SUBTREE_SCOPE);

	    NamingEnumeration<javax.naming.directory.SearchResult> answers = context.search(base_dn, "(uid=" + username + ")", ctrls);
	    javax.naming.directory.SearchResult result = answers.nextElement();

	    String user = result.getNameInNamespace();
	    
	    try {
	        props = new Properties();
	        props.put(Context.INITIAL_CONTEXT_FACTORY, initial_context_factory);
	        props.put(Context.PROVIDER_URL, ldap_host);
	        props.put(Context.SECURITY_PRINCIPAL, user);
	        props.put(Context.SECURITY_CREDENTIALS, password);
	        context = new InitialDirContext(props);
	   
	    } catch (Exception e) {
	        return false;
	    }
	    return true;
	}
}


