package ve.gob.cnti.gestion.utils;

import java.util.Enumeration;
import java.util.ResourceBundle;
import java.util.Vector;
public class PropertiesReader {

	/**Obtiene una propiedad del archivo bonita.properties
	 *
	 * @param key Propiedad a buscar en el archivo
	 *
	 * @return <strong>String</strong> Valor de la propiedad buscada
	 */
	public String bonitaProperties(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.bonita");
		return recursos.getString(key);
	}

	/**Obtiene una propiedad del archivo io.properties
	 *
	 * @param key Propiedad a buscar en el archivo
	 *
	 * @return <strong>String</strong> Valor de la propiedad buscada
	 */
	public String ciudadanoProperties(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.ciudadano");
		return recursos.getString(key);
	}

	/**Obtiene una propiedad del archivo alfresco.properties
	 *
	 * @param key Propiedad a buscar en el archivo
	 *
	 * @return <strong>String</strong> Valor de la propiedad buscada
	 *
	 * @author Joaquin Pereira
	 */
	public String getAlfrescoProperty(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.alfresco");
		return recursos.getString(key);
	}

	/**Obtiene una propiedad del archivo i18n.properties
	 *
	 * @param key Propiedad a buscar en el archivo
	 *
	 * @return <strong>String</strong> Valor de la propiedad buscada
	 *
	 * @author Joaquin Pereira
	 */
	public String getI18nProperty(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("i18n");
		return recursos.getString(key);
	}

	/**Obtiene una propiedad del archivo institucion.properties
	 *
	 * @param key Propiedad a buscar en el archivo
	 *
	 * @return <strong>String</strong> Valor de la propiedad buscada
	 *
	 * @author Joaquin Pereira
	 */
	public String getInstitutionProperty(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.institucion");
		return recursos.getString(key);
	}

	public String getJDBCProperty(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.jdbc");
		return recursos.getString(key);
	}

	/**Obtiene una propiedad del archivo io.properties
	 *
	 * @param key Propiedad a buscar en el archivo
	 *
	 * @return <strong>String</strong> Valor de la propiedad buscada
	 */
	public String IOProperties(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.io");
		return recursos.getString(key);
	}

	// obtiene los valores de configuracion del archivo jms.properties

	public String jmsProperties(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.jms");
		return recursos.getString(key);

	}
	
	/**Obtiene una propiedad del archivo ldap.properties
	 *
	 * @param key Propiedad a buscar en el archivo
	 *
	 * @return <strong>String</strong> Valor de la propiedad buscada
	 *
	 * @author José Francisco Luis Medina
	 */
	public String getLdapProperty(String key) {

		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.ldap");
		return recursos.getString(key);
	}
	
	/** Obtiene una propiedad del archivo bandeja.properties
	 * 
	 * @param key Proiedad a buscar en el archivo
	 * 
	 * @return <Strong>String</Strong> valor de la propiedad buscada
	 * 
	 * @author wildeer rumbos
	 * 
	 */
	
	public String bandejaProperty(String key){
		
		ResourceBundle recursos = ResourceBundle.getBundle("ve.gob.cnti.gestion.resources.bandeja");
		return recursos.getString(key);
	}
	
	/**Obtiene todas las claves de un archivo properties
	 *
	 * @param pathFileProperties Lugar de la paqueteria donde se encuentra el archivo properties
	 *
	 * @return <strong> Vector<String></strong> claves encontradas en el archivo
	 */
	public Vector<String> propertiesGetKeys(String pathFileProperties) {

		ResourceBundle recursos = ResourceBundle.getBundle(pathFileProperties);

		Enumeration<String> keys = recursos.getKeys();

		Vector<String> claves = new Vector<String>();

		while (keys.hasMoreElements()) {

			claves.add((String)keys.nextElement());

		}

		return claves;

	}

}