package ve.gob.cnti.gestion.utils;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.math.BigInteger;
import java.net.URL;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.event.PhaseId;
//TODO migracion bandeja
//import javax.portlet.PortletRequest; //migracion bandeja
//import javax.portlet.PortletResponse; //migracion bandeja
//import javax.servlet.http.HttpServletResponse; //migracion bandeja


import javax.servlet.http.HttpServletResponse;


import org.apache.commons.io.IOUtils;
import org.bonitasoft.engine.session.APISession;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.primefaces.model.DefaultStreamedContent;
import org.primefaces.model.StreamedContent;
import org.primefaces.model.UploadedFile;
import org.xhtmlrenderer.pdf.ITextRenderer;

import ve.gob.cnti.gestion.alfresco.ICmisController;
import ve.gob.cnti.gestion.alfresco.impl.AlfrescoLoadFiles;
import ve.gob.cnti.gestion.alfresco.impl.ContentStream;
import ve.gob.cnti.gestion.bonitaImpl.SessionImpl;
import ve.gob.cnti.gestion.exceptions.ConnectionComponentException;
import ve.gob.cnti.gestion.jms.ConnectionJMS;
import ve.gob.cnti.gestion.utils.annotations.FieldIsActuacion;

import com.j256.simplemagic.ContentInfo;
import com.j256.simplemagic.ContentInfoUtil;
//TODO migracion bandeja
//import com.liferay.portal.kernel.exception.PortalException;
//import com.liferay.portal.kernel.exception.SystemException;
//import com.liferay.portal.model.User;
//import com.liferay.portal.util.PortalUtil;
import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
import com.sun.jersey.api.json.JSONConfiguration;

@ManagedBean(name = "liferayUtils", eager = true)
@RequestScoped
public class Utils {
	 private StreamedContent streamedContent;
	private final String TEMP_FILE = System.getProperty("java.io.tmpdir");
	PropertiesReader pr = new PropertiesReader();	
	public String REPOSITORY_URL = pr.getAlfrescoProperty("REPOSITORY_URL");
	/**
	 * @author Joaquin Pereira & Yoel Jerez
	 * 
	 * @param obj
	 *            = Objeto del bean a convertir a List Map
	 * @return {@link List} Lista de Map de valores del objeto bean convertido
	 * 
	 */
	public List<Map<String, Object>> convertObjectToListMap(Object obj)
			throws IllegalAccessException, IllegalArgumentException,
			InvocationTargetException {
		List<Map<String, Object>> listMaps = new ArrayList<Map<String, Object>>();
		Class<?> pomClass = obj.getClass();
		pomClass = obj.getClass();
		Field[] atributos = pomClass.getDeclaredFields();
		for (Field m : atributos) {
			Map<String, Object> map = new HashMap<String, Object>();
			m.setAccessible(true);
			if (m.isAnnotationPresent(FieldIsActuacion.class)) {
				if (m.get(obj) instanceof Date) {
					map.put(m.getName(), ((Date) m.get(obj)));
				}
				else {
					map.put(m.getName(), m.get(obj));
				}			
			
			}
			
			listMaps.add(map);
		}
		System.out.println("esto es listmap"+listMaps.toString());
		
		return listMaps;
	}

	/**
	 * Método que convierte las variables con sus valores recuperados desde el
	 * BPM al objeto correspondiente del formulario de la tarea definido.
	 * 
	 * @author Joaquin Pereira
	 * @param list
	 *            = Lista de variables con su valores en string recuperados
	 *            desde el BPM
	 * @param obj
	 *            = Objeto del bean que recibe los valores traidos desde el BPM
	 * @return {@link Object} obj bean con sus valores casteados
	 */
	public Object convertListMapToObject(List<Map<String, String>> list,
			Object obj) throws IllegalAccessException,
			IllegalArgumentException, InvocationTargetException, ParseException {
		Class<?> pomClass = obj.getClass();
		pomClass = obj.getClass();
		Field[] atributos = pomClass.getDeclaredFields();
		for (Field m : atributos) {
			m.setAccessible(true);
			Iterator<Map<String, String>> ite = list.iterator();
			while (ite.hasNext()) {
				Map<String, String> map = ite.next();				
				if (m.getName().contentEquals(map.get("name")) && !map.get("value").contentEquals("null")) {
					if (map.get("type").contentEquals("java.util.Date")) {
						if(map.get("value")!=""){
							DateFormat df = new SimpleDateFormat(
									"EEE MMM dd kk:mm:ss z yyyy", Locale.ENGLISH);
							Date dateObj = df.parse(map.get("value"));
							m.set(obj, dateObj);
						}
					} else if (m.get(obj) instanceof Byte) {						
						m.set(obj, Byte.parseByte(map.get("value")));
					} else if (m.get(obj) instanceof Short) {
						m.set(obj, Short.parseShort(map.get("value")));
					} else if (m.get(obj) instanceof Integer) {
						m.set(obj, Integer.parseInt(map.get("value")));
					} else if (m.get(obj) instanceof Long) {
						System.out.println("value"+map.get("value"));
						m.set(obj, Long.parseLong(map.get("value")));
					} else if (m.get(obj) instanceof Float) {
						m.set(obj, Float.parseFloat(map.get("value")));
					} else if (m.get(obj) instanceof Double) {
						m.set(obj, Double.parseDouble(map.get("value")));
					} else if (m.get(obj) instanceof Character) {
						m.set(obj, map.get("value").charAt(0));
					} else if (m.get(obj) instanceof Boolean) {
						m.set(obj, Boolean.parseBoolean(map.get("value")));
					} else if (map.get("type")
							.contentEquals("java.lang.String")) {
						m.set(obj, map.get("value"));
					}else if (map.get("type")
							.contentEquals("java.util.Collection")) {
						if (!map.get("name").matches("^_FILE_.*$")) {
							m.set(obj, map.get("value").toString());
						}else {
							//TODO ARREGLAR LAS COLLECTIONS
							List<String> temp = new ArrayList<String>();
							if(!"[]".contentEquals(map.get("value"))){
								String stringTemp = map.get("value");
								String stringTempVec[] = stringTemp.split(",");
								for(String ss : stringTempVec){
									ss=ss.replace("[", "");
									ss=ss.replace("]", "");
									ss=ss.replaceAll(" ", "");
									temp.add(ss);
								}
								String aMethod = (String) map.get("name");
								char primeraLetra = aMethod.charAt(0);
								String nameMethod = "set"+Character.toUpperCase(primeraLetra)+aMethod.substring(1);
								try {
									Method metodo = obj.getClass().getMethod(nameMethod,List.class);
									metodo.invoke(obj, temp);
								} catch (NoSuchMethodException e) {
									e.printStackTrace();
								} catch (SecurityException e) {
									e.printStackTrace();
								}
							}					
						}

					}
				}
			}
		}
		return obj;
	}

	/**
	 * Devuelve la fecha en el formato especificado en el patrón
	 * 
	 * El tipo de Fecha Recuperdada debe venir por defecto con el patron
	 * <strong>EEE MMM dd kk:mm:ss z yyyy</strong>
	 * 
	 * @author Joaquin Pereira
	 * @param pattern
	 *            = Patrón que especifica como se debe devolver la fecha
	 * @param date
	 *            = Fecha que se quiere formatear
	 * @return String de la fecha formateada
	 */
	public String getFormattedDate(String pattern, String date) {
		String fecha = null;
		try {
			DateFormat df = new SimpleDateFormat("EEE MMM dd kk:mm:ss z yyyy",
					Locale.ENGLISH);
			Date dateObj = df.parse(date);
			fecha = new SimpleDateFormat(pattern).format(dateObj);
		} catch (ParseException e1) {
			e1.printStackTrace();
		}
		return fecha;
	}

	/**
	 * Devuelve la fecha en el formato especificado en el patrón El tipo de
	 * Fecha Recuperdada debe venir por defecto con el patron <strong>yyyy-MM-dd
	 * HH:mm:ss.S</strong>
	 * 
	 * @author Joaquin Pereira
	 * @param pattern
	 *            = Patrón que especifica como se debe devolver la fecha
	 * @param date
	 *            = Fecha que se quiere formatear
	 * @return String de la fecha formateada
	 */
	public String getSympleFormattedDate(String pattern, String date) {
		String fecha = null;
		try {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S");
			Date dateObj = df.parse(date);
			fecha = new SimpleDateFormat(pattern).format(dateObj);
		} catch (ParseException e1) {
			e1.printStackTrace();
		}
		return fecha;
	}

	/**
	 * Devuelve un objeto con los datos del usuario de liferay logueado
	 * 
	 * @author Joaquin Pereira
	 * @return com.liferay.portal.model.User modelo con los datos de usuario
	 *         logueado
	 */
	//TODO migracion bandeja
	/*
	public User getUserLiferaySession() throws PortalException, SystemException {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		PortletRequest portletRequest = (PortletRequest) facesContext
				.getExternalContext().getRequest();
		User usuario = PortalUtil.getUser(portletRequest);
		return usuario;
	}*/

	
	/**
	 * Devuelve un objeto con los datos del usuario de liferay logueado
	 * 
	 * @param key
	 *            = Identificador del valor a buscar en la sesión del portal
	 *            liferay
	 * @return valor buscado en la sesión
	 * @author Joaquin Pereira
	 */
	/*
	public String getValueToLiferaySession(String key) throws PortalException,
			SystemException {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		PortletRequest portletRequest = (PortletRequest) facesContext
				.getExternalContext().getRequest();
		return (String) portletRequest.getPortletSession().getAttribute(key);
	}*/ //TODO migracion bandeja

	/**
	 * Guarda un string en el ambito de la sesión del portal liferay
	 * 
	 * @param key
	 *            = Identificador del valor a guardar en la sesión del portal
	 *            liferay
	 * @param value
	 *            = valor a guardar en la sesión del portal liferay
	 * @author Joaquin Pereira
	 */ /*
	public void setValueToLiferaySession(String key, String value)
			throws PortalException, SystemException {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		PortletRequest portletRequest = (PortletRequest) facesContext
				.getExternalContext().getRequest();
		portletRequest.getPortletSession().setAttribute(key, value);
	} */ //TODO migracion bandeja

	/**
	 * Método que permite descargar un archivo obtenido de alfresco.
	 * 
	 * El código fue tomado de:
	 * http://www.kianworknotes.com/2013/03/primefaces-filedownload
	 * -in-liferay.html
	 * 
	 * Esto permite resolver un problema de compatibilidad de primefaces en el
	 * ámbito de los portlets.
	 * 
	 * @param documentID
	 *            = id del documento guardado en alfresco.
	 * @author Joaquin Pereira
	 * @return {@link StreamedContent} nulo debido a que el archivo es
	 *         directamente escrito en {@link HttpServletResponse}
	 * @throws Exception
	 */
	
	public StreamedContent getDownloadFile(String documentID) throws Exception {
		//TODO migracion bandeja
	
		// 1. initialize the fileInputStream
		ICmisController iCmisController = new AlfrescoLoadFiles();//
		ContentStream cs = iCmisController.getDocument(documentID);
		InputStream fis = cs.getStream();

		// 2. get Liferay's ServletResponse
		ExternalContext context = (ExternalContext) FacesContext
				.getCurrentInstance().getExternalContext();
		streamedContent=new DefaultStreamedContent(fis, cs.getMimeType());
		 if (streamedContent != null)
			 streamedContent.getStream().reset(); //reset stream to the start position!
         return streamedContent;
		
		/*HttpServletResponse res = (HttpServletResponse)context.getResponse();

		res.setHeader("Content-Disposition",
				"attachment; filename=\"" + cs.getFileName() + "\"");//
		res.setHeader("Content-Transfer-Encoding", "binary");
		res.setContentType(cs.getMimeType());
		res.flushBuffer();

		// 3. write the file into the outputStream
		OutputStream out = res.getOutputStream();
		byte[] buffer = new byte[4096];
		int bytesRead;
		while ((bytesRead = fis.read(buffer)) != -1) {
			out.write(buffer, 0, bytesRead);
			buffer = new byte[4096];
		}*/
		

		// 4. return null to this method
		//return null;
	}

	/**
	 * Método que valida si un archivo existe, sea del tipo PDF y su peso sea
	 * menor de 2 mb
	 * 
	 * @author Joaquin Pereira
	 * @param uFile
	 *            = Archivo a validar
	 * @param uiID
	 *            = identificador de la etiqueta de mensaje que recibe la
	 *            validación
	 * @return {@link boolean} true si debe validar, false en caso contrario
	 * @throws IOException
	 */
	public boolean filePDFValidate(UploadedFile uFile, String uiID) {

		final String mimeType = "application/pdf";
		final long sizeFile = 2097152L;

		if (uFile == null) {
			setMessageToView("Todos los archivos son requeridos", 1);
			return true;
		} else if (!uFile.getContentType().contentEquals(mimeType)) {
			setMessageToView("Todos los archivos deben ser del tipo PDF", 1);
			return true;
		} else if (uFile.getSize() > sizeFile) {
			setMessageToView("Todos los archivos deben ser menores a 2MB", 1);
			return true;
		}
		return false;
	}

	/**
	 * Método que valida si un archivo existe, sea del tipo PDF y su peso sea
	 * menor de 2 mb
	 * 
	 * @author Joaquin Pereira
	 * @param uFile
	 *            = Archivo a validar
	 * @param uiID
	 *            = identificador de la etiqueta de mensaje que recibe la
	 *            validación
	 * @return {@link boolean} true si debe validar, false en caso contrario
	 * @throws IOException
	 */
	public boolean filePDFValidateFirmado(UploadedFile uFile, String uiID) {

		final String mimeType = "application/pdf";
		final long sizeFile = 2097152L;

		if (uFile == null) {
			setMessageToView("El archivo es requerido", 1);
			return true;
		} else if (uFile.getContentType().contentEquals(
				"application/force-download")
				|| uFile.getContentType().contentEquals(
						"application/x-download")) {
			ContentInfoUtil util = new ContentInfoUtil();
			ContentInfo info;

			try {
				info = util.findMatch(uFile.getInputstream());
				if (!info.getMimeType().contentEquals(mimeType)) {
					setMessageToView("El archivo debe ser del tipo PDF", 1);
					return true;
				} else if (uFile.getSize() > sizeFile) {
					setMessageToView("El archivo debe ser menor a 2MB", 1);
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else if (!uFile.getContentType().contentEquals(mimeType)) {
			setMessageToView("El archivo debe ser del tipo PDF", 1);
			return true;
		} else if (uFile.getSize() > sizeFile) {
			setMessageToView("El archivo debe ser menor a 2MB", 1);
			return true;
		}

		return false;
	}
	
	
	public InputStream getDownloadFile(String documentID, String prueba) throws Exception {
		//TODO migracion bandeja
	
		
		ICmisController iCmisController = new AlfrescoLoadFiles();//
		ContentStream cs = iCmisController.getDocument(documentID);
		InputStream fis = cs.getStream();
        return fis;
		
	}

	/**
	 * Obtiene de Alfresco mediante CMIS un pdf, con el hash pasado en la
	 * petición. Método que se utiliza en el visor de PDF de primefaces.
	 * 
	 * @return {@link StreamedContent} flujo de contenido de un archivo pdf
	 * @author Joaquin Pereira
	 */
	public StreamedContent getStreamPdfFile(){
		FacesContext context = FacesContext.getCurrentInstance();
		if (context.getCurrentPhaseId() != PhaseId.RENDER_RESPONSE) {
			String id = context.getExternalContext().getRequestParameterMap()
					.get("id");
			if (id == null) {
				return null;
			} else {
				if(id.length()==0){
					return null;
				}
				ICmisController iCmisController = new AlfrescoLoadFiles();
				ContentStream cs = iCmisController.getDocument(id);
				if(cs!=null){
					InputStream fis = cs.getStream();
					StreamedContent sc = new DefaultStreamedContent(fis,
							"application/pdf");
					return sc;
				}
				return defaultStreamedContent();
			}
		}else{
			return defaultStreamedContent();
		}
	}
	
	public StreamedContent getStreamPdfFile(String id){
		FacesContext context = FacesContext.getCurrentInstance();
		
		
		if (context.getCurrentPhaseId() != PhaseId.RENDER_RESPONSE) {	
			
			if (id == null) {
				return defaultStreamedContent();
			} else {
				if(id.length()==0){
					return defaultStreamedContent();
				}
				ICmisController iCmisController = new AlfrescoLoadFiles();
				ContentStream cs = iCmisController.getDocument(id);
				if(cs!=null){
					InputStream fis = cs.getStream();
					StreamedContent sc = new DefaultStreamedContent(fis,
							"application/pdf");
					return sc;
				}
				return defaultStreamedContent();
			}
		}else{
			return defaultStreamedContent();
		} 
			
					
	}
	
	
	public StreamedContent defaultStreamedContent(){
		StreamedContent sc = new DefaultStreamedContent();
		return sc;
	}

	/**
	 * Obtiene la ruta absoluta en File System de una vista o ruta de
	 * directorios. Dichas rutas son referentes a las vista.
	 * 
	 * @author Joaquin Pereira.
	 * @param path
	 *            Ruta relativa de un directorio o vista.
	 * @return Ruta absoluta en File System de una vista o ruta de directorios
	 */
	public String getRealPath(String path) {
		URL rutaClass = Utils.class.getProtectionDomain().getCodeSource()
				.getLocation();
		String ruta = rutaClass.toString();
		ruta = ruta.split("/WEB-INF/")[0];
		ruta = ruta.split(":")[1];
		return ruta + path;
	}

	/**
	 * Método que genera un pdf a partir de la actuación sobre una tarea.
	 * 
	 * @param pathPlantilla
	 *            path relativo en donde se encuentra la plantilla para generar
	 *            la actuación.
	 * @param pathAlfresco
	 *            path en alfresco en donde se guardara el PDF de la actuación
	 *            generado.
	 * @param namePDF
	 *            Nombre del PDF con el que se guardara la actuación generada.
	 * @param content
	 *            Contenido de la actuación.
	 * 
	 * @return {@link String} <b>Id</b> en alfresco en donde se guardo la
	 *         actuación.
	 * @throws IOException
	 * @author Joaquin Pereira y Alexis Veliz
	 */
	public String createPDF(String pathPlantilla, String pathAlfresco,
			String namePDF, String content) {
		String id = "";
		try {
			// Obteniendo Contenido de la plantilla y obteniendo la ruta
			// absoluta del directorio de la plantilla.
			String htmlcontent = "";
			String path = getRealPath(pathPlantilla);
			FileInputStream inputStream = new FileInputStream(path
					+ "view.xhtml");
			htmlcontent = IOUtils.toString(inputStream);
			inputStream.close();

			// Parseando y LLenando el HTML con los datos de la actuación.
			Document doc = Jsoup.parse(htmlcontent, "UTF-8");

			// Guardando el contenido de la actuación en el html
			doc.getElementById("content").html(content);

			// Obteniendo las imagenes de la plantilla para inyectar el path
			// absoluto.
			Elements media = doc.select("[src]");
			int i = 1;
			for (Element src : media) {
				if (src.tagName().equals("img")) {
					String src2 = src.attr("src");
					doc.getElementById("imagen_" + i).removeAttr("src");
					doc.getElementById("imagen_" + i).attr("src", path + src2);
				}
				i++;
			}

			// Inyectando la ruta Absoluta al css.
			doc.getElementById("cssMain").removeAttr("href");
			doc.getElementById("cssMain").attr("href", path + "view.css");

			// Inyectando la la ruta Absoluta a la imagen de la cabecera
			String style[] = doc.select("style").first().data().split("'");
			doc.select("style").first()
					.html(style[0] + "'" + path + style[1] + "'" + style[2]);

			// Operaciones de Creación del PDF con la libreria ITEX
			OutputStream os = null;
			File fileTemp = new File(TEMP_FILE+"/"+namePDF + ".pdf");
			os = new FileOutputStream(fileTemp);
			ITextRenderer renderer = new ITextRenderer();
			renderer.setDocumentFromString(doc.html());
			renderer.layout();
			renderer.createPDF(os);
			os.close();

			// Subida de PDF Creado a alfresco
			ICmisController iCmisController = new AlfrescoLoadFiles();
			id = iCmisController.uploadDocument(fileTemp, pathAlfresco,fileTemp.getName());

			// Borrando Archivo Temporal del Sistema.
			fileTemp.delete();
			return id;
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}
		return id;
	}
	
	public String readPdfTemplate(String pathPlantilla){
		String htmlcontent = "";
		try {					
			String path = getRealPath(pathPlantilla);
			FileInputStream inputStream = new FileInputStream(path
					+ "templatePDF.xhtml");
			htmlcontent = IOUtils.toString(inputStream);
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}
		return htmlcontent;
	}
	
	public String createPDF(String pathAlfresco,
			String namePDF, String content) {
		String id = "";
		try {
			// Operaciones de Creación del PDF con la libreria ITEX
			OutputStream os = null;
			File fileTemp = new File(TEMP_FILE+"/"+namePDF + ".pdf");
			os = new FileOutputStream(fileTemp);
			ITextRenderer renderer = new ITextRenderer();
			renderer.setDocumentFromString(content);
			renderer.layout();
			renderer.createPDF(os);
			os.close();
			// Subida de PDF Creado a alfresco
			ICmisController iCmisController = new AlfrescoLoadFiles();
			id = iCmisController.uploadDocument(fileTemp, pathAlfresco,fileTemp.getName());
			// Borrando Archivo Temporal del Sistema.
			fileTemp.delete();
			return id;
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}
		return id;
	}
	
	

	/**
	 * Envia un mensaje a la vista.
	 * 
	 * @param msj
	 *            Cuerpo del mensaje.
	 * @param type
	 *            Severidad del mensaje
	 *            <ul>
	 *            <li><b>1</b> = Error</li>
	 *            <li><b>2</b> = Fatal</li>
	 *            <li><b>3</b> = Info</li>
	 *            <li><b>4</b> = Warn</li>
	 *            </ul>
	 * 
	 * @author Joaquin Pereira
	 */
	public void setMessageToView(String msj, int type) {
		FacesMessage fm = new FacesMessage();
		switch (type) {
		case 1:
			fm.setSeverity(FacesMessage.SEVERITY_ERROR);
			break;
		case 2:
			fm.setSeverity(FacesMessage.SEVERITY_FATAL);
			break;
		case 3:
			fm.setSeverity(FacesMessage.SEVERITY_INFO);
			break;
		case 4:
			fm.setSeverity(FacesMessage.SEVERITY_WARN);
			break;
		default:
			break;
		}
		FacesContext.getCurrentInstance().addMessage(null,
				new FacesMessage(fm.getSeverity(), msj, ""));
	}

	@SuppressWarnings("unused")
	private String cleanHtml(String htmlCrudo) {

		System.out.println("htmlCrudo \n" + htmlCrudo);

		// Create instance
		org.w3c.tidy.Tidy tidy = new org.w3c.tidy.Tidy();

		// Remove presentational clutter (don't really know
		// what exactly that does, but sounds great ;-)
		tidy.setMakeClean(true);

		// Use XHTML output
		tidy.setXHTML(true);

		// Make document readable by indenting the elements
		tidy.setSmartIndent(true);

		// The html document received by a get request
		final String s = htmlCrudo;

		// Converting the page into a Document instance
		org.w3c.dom.Document document = tidy.parseDOM(new ByteArrayInputStream(
				s.getBytes()), null);

		// Create a stream to write the output to
		final ByteArrayOutputStream outStr2 = new ByteArrayOutputStream();

		// Write modified Document to an output stream
		tidy.pprint((org.w3c.dom.Document) document, outStr2);

		// Create a StringBuilder
		final StringBuilder builder = new StringBuilder();

		// Write output stream content to string builder
		try {
			builder.append(new String(outStr2.toByteArray(), "UTF-8"));
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}

		// Create String
		String validXHTML = builder.toString();

		System.out.println("validXHTML \n" + validXHTML);

		return validXHTML;
	}

	/**
	 * Retorna un string legible del tamaño de un archivo
	 * 
	 * @param size
	 *            Tamaño del archivo representado en bytes
	 * @return string legible del tamaño de un archivo
	 * @author Joaquin Pereira
	 */
	public String getStringSizeLengthFile(long size) {

		DecimalFormat df = new DecimalFormat("0.00");

		float sizeKb = 1024.0f;
		float sizeMo = sizeKb * sizeKb;
		float sizeGo = sizeMo * sizeKb;
		float sizeTerra = sizeGo * sizeKb;

		if (size < sizeMo)
			return df.format(size / sizeKb) + " Kb";
		else if (size < sizeGo)
			return df.format(size / sizeMo) + " Mb";
		else if (size < sizeTerra)
			return df.format(size / sizeGo) + " Gb";

		return "";
	}
	
	
	public String getSympleFormattedDate(String patternToConver,String patternByDefault, String date) {
		String fecha = null;
		try {
			DateFormat df = new SimpleDateFormat(patternByDefault,Locale.ENGLISH);
			Date dateObj = df.parse(date);
			fecha = new SimpleDateFormat(patternToConver,Locale.ENGLISH).format(dateObj);
		} catch (ParseException e1) {
			e1.printStackTrace();
		}
		return fecha;
	}
	
	/**
	 * Devuelve la fecha en el formato especificado en el patrón El tipo de
	 * Fecha Recuperdada debe venir por defecto con el patron <strong>yyyy-MM-dd
	 * HH:mm:ss, se coloco el Locale.ENGLISH para no depender de los locales del
	 * servidor</strong>
	 * 
	 * @author Joaquin Pereira
	 * @param pattern
	 *            = Patrón que especifica como se debe devolver la fecha
	 * @param date
	 *            = Fecha que se quiere formatear
	 * @return String de la fecha formateada
	 */
	public String getSympleFormattedDateUS(String pattern, String date) {
		String fecha = null;
		DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S",
				Locale.ENGLISH);
		Date dateObj = null;

		try {
			dateObj = df.parse(date);
			fecha = new SimpleDateFormat(pattern, Locale.ENGLISH)
					.format(dateObj);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return fecha;
	}
	
	/**
	 * Formatea la cadena a UTF8 
	 * @param s la cadena a convertir
	 * @return la cadena convertida
	 */
	public static String convertStringToUTF8(String s) {
		String out = null;
		try {
			out = new String(s.getBytes("UTF-8"), "UTF-8");
		} catch (java.io.UnsupportedEncodingException e) {
			return null;
		}
		return out;
	}
	
	/**
	 * Aplica UTF8 a una lista de cadenas.
	 * @param lista a convertir
	 * @return lista convertida a UTF8
	 */
	public List<String> convertlistStringToListStringUTF8(List<String> list) {
		List<String> temp = new ArrayList<String>();
		for (String s : list) {
			s = convertStringToUTF8(s);
			temp.add(s);
		}
		return temp;
	}	
	
	/**
	 * Obtener MD5 de un String
	 */
	public static String getMD5(String input) {
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");
			byte[] messageDigest = md.digest(input.getBytes());
			BigInteger number = new BigInteger(1, messageDigest);
			String hashtext = number.toString(16);
			// Now we need to zero pad it if you actually want the full 32
			// chars.
			while (hashtext.length() < 32) {
				hashtext = "0" + hashtext;
			}
			return hashtext;
		} catch (NoSuchAlgorithmException e) {
			throw new RuntimeException(e);
		}
	}
	
	/**
	 * verifica que el servidor de bonita, el servidor de mensajeria y alfresco esten activos
	 * @param  ninguno
	 * @return ninguno
	 */
 
	public void validateComponents() throws ConnectionComponentException{
	   
	  

	   ConnectionJMS connectionJMS=new ConnectionJMS();
	   try{
		   connectionJMS.openConnection(connectionJMS.getDEFAULT_EMAIL_DESTINATION());
		   if(connectionJMS.getConnection()!=null){
			   connectionJMS.closeConection();	
			   
		   }else{		   
			   throw new ConnectionComponentException("La Plataforma JMS");		   
		   } 	   
	   }catch(Exception e){
		 throw new ConnectionComponentException("La Plataforma JMS");	
	   }
	   
	   
       ClientConfig clientConfig = new DefaultClientConfig();
       
       clientConfig.getFeatures().put(
               JSONConfiguration.FEATURE_POJO_MAPPING, Boolean.TRUE);

       Client client = Client.create(clientConfig);

       WebResource webResource = client
               .resource(REPOSITORY_URL+"rest/fileDownload/test");

     
       ClientResponse response = webResource.accept("application/json")
           .type("application/json").get(ClientResponse.class);

       if (response.getStatus() != 200) {
    	   throw new ConnectionComponentException("Repository Failed : HTTP error code : "
                   + response.getStatus());           
       }

       
       String output = response.getEntity(String.class);

       if(!output.equals("ok"))throw new ConnectionComponentException("Repository Failed : HTTP error code : "
               + response.getStatus());     

   
	   PropertiesReader properties = new PropertiesReader();
	   String ADMIN_USERNAME = properties.bonitaProperties("ADMIN_USERNAME");
	   String ADMIN_PASSWORD = properties.bonitaProperties("ADMIN_PASSWORD");
	   	   
	   SessionImpl sessionImpl = new SessionImpl();
	   APISession apiSession = null;
		try {
			apiSession = sessionImpl.startEngineConection(ADMIN_USERNAME, ADMIN_PASSWORD);		
		} catch (Exception e) {
			// TODO Auto-generated catch block
			throw new ConnectionComponentException("Bonita");
		}	
		
	}
	
	public static void addGlobalInfoFlashMessage(String message) {
	    FacesContext context = FacesContext.getCurrentInstance();
	    context.getExternalContext().getFlash().setKeepMessages(true);
	    context.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, message, ""));
	}
	
	public static void addGlobalErrorFlashMessage(String message) {
	    FacesContext context = FacesContext.getCurrentInstance();
	    context.getExternalContext().getFlash().setKeepMessages(true);
	    context.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, message, ""));
	}
	
	
}
