package ve.gob.cnti.gestion.utils.validators;

import java.util.List;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

/**Conjunto de métodos validadores, que son usados en los controladores debidos 
 * a problemas de implementación en los validadores customs de jsf.
 * 
 * @author Joaquin Pereira
 */
public class MiscellaneousValidators {

	/**Valida que si una tarea posee reparo al menos se halla tomado un motivo de devolución.
	 * 
	 * @param discriminant Valor string de rechazo que activa la validación.
	 * @param discriminantVal Valor elegido del radio button o select a comparar para poder activar la validación.
	 * @param reasons Las razones de devolución de un caso.
	 * @param uiID = identificador de la etiqueta de mensaje que recibe la validación.
	 * @return <b>true</b> si el campo esta correcto, <b>false</b> en caso contrario. 
	 * @author Joaquin Pereira
	 */
	public boolean ReasonsValidator(String discriminant, String discriminantVal, List<String> reasons,String uiID){
		
		//Se valida que la razon de devolución halla sido tomada por el usuario
		if (discriminant.contentEquals(discriminantVal)) {
			
			//Se valida que al menos se halla tomado un motivo de devolución.
			if(reasons == null || reasons.size()<1){
				FacesContext.getCurrentInstance().addMessage(null, 
						new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error!", 
								"Debe Seleccionar al menos un motivo de devolución"));			
				return false;			
			}
		}
		
		return true;
	}
}
