package ve.gob.cnti.gestion.utils.validators;

import java.util.ArrayList;
import java.util.List;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import ve.gob.cnti.gestion.utils.PropertiesReader;

@FacesValidator("PassValidator")
public class PassValidator implements Validator {

	@Override
	public void validate(FacesContext context, UIComponent component,
			Object value) throws ValidatorException {
		boolean hasUppercase = !value.toString().equals(value.toString().toLowerCase());
        boolean hasLowercase = !value.toString().equals(value.toString().toUpperCase());
        boolean hasNumber = value.toString().matches(".*\\d.*");
        boolean noSpecialChar = value.toString().matches("[a-zA-Z0-9 ]*");
        
		if (value.toString().length() < 8 || !hasUppercase || !hasLowercase || !hasNumber || noSpecialChar) {
			
			List<FacesMessage> messagelist = new ArrayList<FacesMessage>();
			
			String message = new PropertiesReader()
			.getI18nProperty("mjsPassValidator");
	
			
			FacesMessage msg = 
					new FacesMessage(message, message);
			msg.setSeverity(FacesMessage.SEVERITY_ERROR);
			messagelist.add(msg);
			
			
			if (value.toString().length() < 8) {
				message = "-Mínimo 8 caracteres "; //TODO i18n
				FacesMessage msgLength = 
				new FacesMessage(message, message);
				messagelist.add(msgLength);
	        }

	        if (!hasUppercase) {
	        	message = "-Poseer mayúsculas"; //TODO i18n
	        	FacesMessage msgUppercase = 
						new FacesMessage(message, message);
				messagelist.add(msgUppercase);
	        }

	        if (!hasLowercase) {
	        	message = "-Debe contener minúsculas"; //TODO i18n
	        	FacesMessage msgLowercase = 
						new FacesMessage(message, message);
				messagelist.add(msgLowercase);
	        }

	        if (!hasNumber) {
	        	message = "-Debe contener números"; //TODO i18n
	        	FacesMessage msgNumber = 
						new FacesMessage(message, message);
				messagelist.add(msgNumber);
	        }

	        if(noSpecialChar){
	        	message = "-Debe contener caracteres especiales."; //TODO i18n
	        	FacesMessage msgSpecialChar = 
						new FacesMessage(message, message);
				messagelist.add(msgSpecialChar);
	        }
			
			throw new ValidatorException(messagelist);

		}
		                
	}

}
