package ve.gob.cnti.gestion.utils.validators;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import ve.gob.cnti.gestion.utils.PropertiesReader;

@FacesValidator("PhoneValidator")
public class PhoneValidator implements Validator {

	private static final String PHONE_PATTERN = "^0[0-9]{10}$";

	private Pattern pattern;
	private Matcher matcher;

	public PhoneValidator() {
		pattern = Pattern.compile(PHONE_PATTERN);
	}

	@Override
	public void validate(FacesContext context, UIComponent component,
			Object value) throws ValidatorException {
		if(value!=null){
			matcher = pattern.matcher(value.toString());
			if (!matcher.matches()) {
				String mjs = new PropertiesReader()
						.getI18nProperty("mjsPhoneValidator");
	
				FacesMessage msg = new FacesMessage("", mjs);
				msg.setSeverity(FacesMessage.SEVERITY_ERROR);
				throw new ValidatorException(msg);
			}
		}
	}
}