package ve.gob.cnti.gestion.utils.validators;

import java.util.List;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import org.primefaces.component.selectoneradio.SelectOneRadio;

/**
 * Validador jsf que verifica que se seleccione al menos un motivo de devolución
 * si el discriminante definido conincide con el valor del discriminante seleccionado por el 
 * usuario.
 * 
 * @author Joaquin Pereira
 */
@FacesValidator("ve.gob.cnti.gestion.utils.validators.ReasonsValidator")
public class ReasonsValidator implements Validator{
	
	@Override
	public void validate(FacesContext context, UIComponent component,
			Object value) throws ValidatorException {
		System.out.println("VALIDANDO");
		// Se obtiene el valor del elemento html
		@SuppressWarnings("unchecked")
		List<String> reasons = (List<String>) value;

		// Obtención del componente y su valor enviado desde la petición
//        UIInput discriminantComponent = (UIInput) component.getAttributes().get("discriminante");
//        UIInput discriminantValComponent = (UIInput) component.getAttributes().get("discriminanteVal");
        
        String discriminant = (String) component.getAttributes().get("discriminante");
        String discriminantVal = (String) component.getAttributes().get("discriminanteVal").toString();
        System.out.println("discriminant "+discriminant);
    	System.out.println("discriminantVal "+discriminantVal);
    	
    	org.primefaces.component.selectoneradio.SelectOneRadio sr = (SelectOneRadio) component.getAttributes().get("discriminanteVal");
    	System.out.println("value "+sr.getValue());
    	System.out.println("title "+sr.getTitle());
    	System.out.println("label "+sr.getLabel());
    	System.out.println("id "+sr.getId());
    	
        // Se evaluan los parametros de validación.
        if(discriminant.contentEquals(discriminantVal)){
        	
        	if(reasons == null || reasons.size()<1){
        		
        		FacesMessage msg = new FacesMessage("Validación de motivos fallo.", 
        						"Debe seleccionar al menos un motivo para devolver el expediente.");
        			msg.setSeverity(FacesMessage.SEVERITY_ERROR);
        			throw new ValidatorException(msg);
        	}else{
        		System.out.println("reasons.size() "+reasons.size());
        		System.out.println("reasons.toString() "+reasons.toString());
        	}
        	
        }else{
        	return;
        }
		
	}

}
