package ve.gob.cnti.gestion.utils.validators;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import ve.gob.cnti.gestion.utils.PropertiesReader;

@FacesValidator("TextValidator")
public class TextValidator implements Validator{
	private static final String EMAIL_PATTERN = "^([A-Za-zÑñáÁéÉíÍóÓúÚ ]+)$";

	private Pattern pattern;
	private Matcher matcher;

	public TextValidator(){
		pattern = Pattern.compile(EMAIL_PATTERN);
	}

	@Override
	public void validate(FacesContext context, UIComponent component,
			Object value) throws ValidatorException {

		matcher = pattern.matcher(value.toString());
		if (!matcher.matches()) {

			String mjs = new PropertiesReader()
					.getI18nProperty("mjsTextValidator");

			FacesMessage msg = new FacesMessage(mjs, mjs);
			msg.setSeverity(FacesMessage.SEVERITY_ERROR);
			throw new ValidatorException(msg);

		}

	}
}
